<?php

defined('BASEPATH') OR exit('No direct script access allowed');
  


class Advertiser extends CI_Controller {



	public function __construct()

	{

		parent::__construct();

		 if(empty($this->session->userdata('id')) ) {
      
		 
            $this->session->set_flashdata('flash_data', 'You don\'t have access!');
            redirect('login');
			 
        }
        $this->load->model('advertiser_model','adv');
		$this->load->model('publication_model','pubs');
		$this->load->model('advertiserActivity_model','activity');
 $this->load->model('UserPrivileges_model','privilege');
		$this->load->helper('url'); // to load header footer or anyother url related links....

		$this->load->library('upload'); // to upload image

		$this->load->helper('directory'); //load directory helper ot show client image from upload folder 

		$this->load->library('form_validation');

		

	}



	public function index()

	{

	 $mydata['pubsInfo'] = $this->pubs->get_all();

		$this->load->view('advertiser/all_advertiser',$mydata);

	}

	

	public function ajax_list()

	{

	$list = $this->adv->get_datatables();
	$data = array();

		$no = $_POST['start'];
        $sn = 1;
		foreach ($list as $pos) {

			$no++;

			$row = array();
            $p_pubs = $this->pubs->get_by_id($pos->publication_id);
			$row[] = $pos->name;
			$row[] = $pos->address;
			$row[] = $pos->contact_name;
			$row[] = $pos->designation;
			 $row[] = $pos->phone;
            $row[] = $p_pubs->name;
			$row[] = '<a class="btn btn-icon-only yellow" href="'.base_url().'advertiser/view/'.$pos->id.'"><i class="fa fa-eye"></i></a><a class="btn btn-icon-only red" href="javascript:void()" title="Edit" onclick="delete_advertiser('."'".$pos->id."'".')"><i class="fa fa-trash"></i></a>  ';

			$data[] = $row;
          $sn++;
		}



		$output = array(

						"draw" => $_POST['draw'],

						"recordsTotal" => $this->pubs->count_all(),

						"recordsFiltered" => $this->pubs->count_filtered(),

						"data" => $data,

						

				);

		//output to json format

		echo json_encode($output);

	}

public function custom_search($pub)
	 {
	 
	 //$data = $this->input->post('publication_id');
	 $mydata['pubsInfo'] = $this->pubs->get_all();
	 $mydata['searchInfo'] = $this->adv->custom_search_result($pub);
         $mydata['pubID'] = $pub;
         $this->load->view('advertiser/advertiser_by_publication',$mydata);
	//echo json_encode(array("status" => TRUE));
	 }


	public function ajax_add()

	{

		$this->_validate();

		$data = array(
                'name' => $this->input->post('name'),
				'address' => $this->input->post('address'),

				'email' => $this->input->post('email'),

				'phone' => $this->input->post('phone'),

				'mobile' => $this->input->post('mobile'),

				'website' => $this->input->post('website'),
				'contact_name' => $this->input->post('contact_name'),
				'designation' => $this->input->post('designation'),
				'contact_email' => $this->input->post('contact_email'),
				'alternative_phone' => $this->input->post('alternative_phone'),
				'note' => $this->input->post('note'),
				'publication_id' => $this->input->post('publication_id'),
				'start_date'=>date('Y-m-d')

				);

		$insert = $this->adv->save($data); // execute the save function from user model

		//$this->authentic->add_to_group($this->input->post('group_id'), $insert);

		echo json_encode(array('id'=>$insert,"status" => TRUE));

	}

	


public function view($id=NULL)

	 {
        $myprev = $this->privilege->get_by_userid($this->session->userdata('id'));
	 $valid = $myprev->advertiser_crud;
	 if($valid == '0')  {
		 
            $this->session->set_flashdata('flash_data', 'You don\'t have access!');
            redirect('dashboard/no_access');
			//exit();
			 
        }
		else {
	 $contact_info['advertiserInfo'] = $this->adv->get_by_id($id);

	 

	 $this->load->view('advertiser/advertiser_details',$contact_info);
       }
	 }

	 public function summary($id=NULL)

	 {

	 $contact_info['advertiserInfo'] = $this->adv->get_by_id($id);

	 

	 $this->load->view('advertiser/advertiser_summary',$contact_info);

	 }
public function activity($id=NULL)

	 {
         $contact_info['advertiserInfo'] = $this->adv->get_by_id($id);
	 $contact_info['activityInfo'] = $this->activity->get_by_advertiser($id);

	 

	 $this->load->view('advertiser/advertiser_activity',$contact_info);

	 }

	public function add_advertiser()

	 {
        $myprev = $this->privilege->get_by_userid($this->session->userdata('id'));
	 $valid = $myprev->advertiser_crud;
	 if($valid == '0')  {
		 
            $this->session->set_flashdata('flash_data', 'You don\'t have access!');
            redirect('dashboard/no_access');
			//exit();
			 
        }
		else {
	$data['pubsInfo'] = $this->pubs->get_all();
	 $this->load->view('advertiser/add_advertiser',$data);

	 }

	 }
public function update_advertiser($id = NULL)

	 {

	$data['pubsInfo'] = $this->pubs->get_all();
	$data['advInfo'] = $this->adv->get_by_id($id);
	 $this->load->view('advertiser/advertiser_profile',$data);

	 

	 }

public function close_advertiser($id=NULL)

	{
	$data = array('status' => 'closed');
    $this->adv->update(array('id' => $id), $data);
   echo json_encode(array("status" => TRUE));

	}

public function activate_advertiser($id=NULL)

	{
	$data = array('status' => 'active');
    $this->adv->update(array('id' => $id), $data);
   echo json_encode(array("status" => TRUE));

	}


	public function ajax_update()

	{

		$this->_validate();

		$data = array(

				 'name' => $this->input->post('name'),
				'address' => $this->input->post('address'),

				'email' => $this->input->post('email'),

				'phone' => $this->input->post('phone'),

				'mobile' => $this->input->post('mobile'),

				'website' => $this->input->post('website'),
				'contact_name' => $this->input->post('contact_name'),
				'designation' => $this->input->post('designation'),
				'contact_email' => $this->input->post('contact_email'),
				'alternative_phone' => $this->input->post('alternative_phone'),
				'note' => $this->input->post('note'),
				'publication_id' => $this->input->post('publication_id'),
				'start_date'=>$this->input->post('start_date')

			);

			

		$this->adv->update(array('id' => $this->input->post('id')), $data);


		echo json_encode(array("status" => TRUE));

	}



	public function ajax_delete($id)

	{

	  

		$this->adv->delete_by_id($id);

		echo json_encode(array("status" => TRUE));

	}

//====== for  dashboard statistics....////////////////

public function monthly_growth($year,$month)
   {
    
     //$this->load->model('Advertiser_model','adv');
    $adv = $this->adv->monthly_growth($year,$month);
   echo json_encode(array("total" => $adv));
   // echo $adv;
   
   }





//////////////// Reporting part //////////////////////
  
  public function reporting()

	{
	
	 $myprev = $this->privilege->get_by_userid($this->session->userdata('id'));
	 $valid = $myprev->publication_report;
	 if($valid == '0')  {
		 
            $this->session->set_flashdata('flash_data', 'You don\'t have access!');
            redirect('dashboard/no_access');
			//exit();
			 
        }
		else {
	
   $mydata['pubsInfo'] = $this->pubs->get_all();
	$mydata['advertiserInfo'] = $this->adv->get_all();
	//if(($allowed->reporting)=='1') {
	$this->load->view('advertiser/all_reports',$mydata);
         //}
        // else { $this->load->view('dashboard'); }
	}
	}
	
	public function by_advertiser()

	{ 
	 $year = $this->input->post('year');
	 $pubs_id = $this->input->post('publication_id');
	  $list['year'] = $year;
	$list['advertiserInfo'] = $this->adv->get_all();
	$list['pubs_id'] = $pubs_id;
	$this->load->view('advertiser/reporting/by_advertiser',$list);
	

	}

public function by_position()

	{ 
	 $year = $this->input->post('year');
	 $pubs_id = $this->input->post('publication_id');
	  $list['year'] = $year;
	//$list['advertiserInfo'] = $this->adv->get_all();
	$list['pubs_id'] = $pubs_id;
	$this->load->view('advertiser/reporting/by_positions',$list);
	

	}
public function by_advertisement_status()

	{ 
	 $pub = $this->input->post('publication_id');
	 $year = $this->input->post('year');
	 $month = $this->input->post('month'); 
	 $start = date("Y-".$month."-01", strtotime($year.'-'.$month.'-01'));// get start date from here
     $end = date("Y-".$month."-t", strtotime($start));
	
	$list['pubsInfo'] = $this->pubs->get_by_id($pub);
	 $list['singlePub'] = $pub;
    $list['start'] = $start;
	$list['end'] = $end;
	$list['year'] = $year;
	$list['month'] = $month;
	
	$this->load->view('advertiser/reporting/by_advertisement_status',$list);
	}
	
public function yearly_advertisement_status()

	{ 
	 $pub = $this->input->post('publication_id');
	 $year = $this->input->post('year');
	 $start = date("Y-01-01", strtotime($year.'-01-01'));// get start date from here
     $end = date("Y-12-t", strtotime($start));
	
	$list['pubsInfo'] = $this->pubs->get_by_id($pub);
	 $list['singlePub'] = $pub;
    $list['start'] = $start;
	$list['end'] = $end;
	$list['year'] = $year;
	
	$this->load->view('advertiser/reporting/yearly_advertisement_status',$list);
	}


	private function _validate()

	{

		$data = array();

		$data['error_string'] = array();

		$data['inputerror'] = array();

		$data['status'] = TRUE;

   if($this->input->post('publication_id') == '0' )

		{

			$data['inputerror'][] = 'publication_id';

			$data['error_string'][] = 'select publication';

			$data['status'] = FALSE;

		}




		if($this->input->post('name') == '' )

		{

			$data['inputerror'][] = 'name';

			$data['error_string'][] = 'Invalid Name';

			$data['status'] = FALSE;

		}
		
		if($this->input->post('email') == '' )

		{

			$data['inputerror'][] = 'email';

			$data['error_string'][] = 'Invalid Email';

			$data['status'] = FALSE;

		}
	


		if($data['status'] === FALSE)

		{

			echo json_encode($data);

			exit();

		}

	}



}

