<?php

defined('BASEPATH') OR exit('No direct script access allowed');



class Client extends CI_Controller {



	public function __construct()

	{

		parent::__construct();

		

		$this->load->model('client_model','person');

		$this->load->model('activity_model','tasks');
		
		$this->load->model('publication_model','pubs');

		//$this->load->model('receipt_model','invoice');

		//$this->load->model('user_model','entryBy');

		$this->load->helper('url'); // to load header footer or anyother url related links....

		$this->load->library('upload'); // to upload image

		$this->load->helper('directory'); //load directory helper ot show client image from upload folder 

		$this->load->library('form_validation');

		

	}



	public function index()

	{

	

		$this->load->view('client/all_clients');

	}

	

	public function ajax_list()

	{

	$list = $this->person->get_datatables();
	$data = array();

		$no = $_POST['start'];

		foreach ($list as $person) {

			$no++;

			$row = array();
			
			

			if($person->image_id) { $row[] = '<div class="profile-userpic"><img src="'.base_url()."uploads/contact/".$person->image_id.'" alt="" class="img-responsive" style="max-width:50px;"></div> '; }
			if(empty($person->image_id)) { $row[] = '<div class="profile-userpic"><img src="'.base_url()."assets/images/placeholder.png".'" alt="" class="img-responsive" style="max-width:50px;"></div> '; }
			

			$row[] = $person->name;
			
			if($person->company) { $row[] = $person->company; } else { $row[] = 'Individual'; }
			

			$row[] = $person->email;

			$row[] = $person->phone;
			$row[] = $person->mobile;			

			$row[] = '<a class="btn btn-icon-only yellow" href="'.base_url().'client/view/'.$person->id.'"><i class="fa fa-eye"></i></a><a class="btn btn-icon-only green" href="'.base_url().'client/view/'.$person->id.'edit"><i class="fa fa-edit"></i></a><a class="btn btn-icon-only red" href="javascript:void()" title="Edit" onclick="delete_contact('."'".$person->id."'".')"><i class="fa fa-trash"></i></a> ';



		

		

			$data[] = $row;

		}



		$output = array(

						"draw" => $_POST['draw'],

						"recordsTotal" => $this->person->count_all(),

						"recordsFiltered" => $this->person->count_filtered(),

						"data" => $data,

						

				);

		//output to json format

		echo json_encode($output);

	}



 public function ajax_edit($id)

	{

		$contact_info = $this->person->get_by_id($id);

		//$data->dob = ($data->dob == '0000-00-00') ? '' : $data->dob; // if 0000-00-00 set tu empty for datepicker compatibility

		

		

		$data = array('id'=>$contact_info->id, 

		               'name'=>$contact_info->name,

					   'company'=>$contact_info->company,

					   'tax_id'=>$contact_info->tax_id,

					   'email'=>$contact_info->email,

					   'phone'=>$contact_info->phone,

					   'mobile'=>$contact_info->mobile,

					   'fax'=>$contact_info->fax,

					   'address'=>$contact_info->address,

					   'city'=>$contact_info->city,

					   'state'=>$contact_info->state,

					   'zip_code'=>$contact_info->zip_code,

					   'country'=>$contact_info->country,

					   'website'=>$contact_info->website,
					   'skypeID'=>$contact_info->skypeID,
					   'contact_type'=>$contact_info->contact_type,
					   'contact_category'=>$contact_info->contact_category,
                        'publication_id' =>$contact_info->publication_id, // company or individual...
					   

					  );

		

		

		echo json_encode($data);

	}



	public function ajax_add()

	{

		$this->_validate();

		$data = array(

				'name' => $this->input->post('name'),

				'company' => $this->input->post('company'),

				'tax_id' => $this->input->post('tax_id'),

				'email' => $this->input->post('email'),

				'phone' => $this->input->post('phone'),

				'mobile' => $this->input->post('mobile'),

				'fax' => $this->input->post('fax'),

				'address' => $this->input->post('address'),

				'city' => $this->input->post('city'),

				'state' => $this->input->post('state_region'),

				'zip_code' => $this->input->post('zip_code'),

				'country' => $this->input->post('country'),

				'website' => $this->input->post('website'),
				'skypeID' => $this->input->post('skypeID'),

				'contact_type' => '1',
              'contact_category' => $this->input->post('contact_category'), // company or individual...
			  'publication_id' => $this->input->post('publication_id'), // company or individual...
				

				

			);

		$insert = $this->person->save($data); // execute the save function from user model

		//$this->authentic->add_to_group($this->input->post('group_id'), $insert);

		echo json_encode(array('id'=>$insert,"status" => TRUE));

	}

	

	public function view($id=NULL)

	 {

	 $contact_info['clientInfo'] = $this->person->get_by_id($id);

	 

	 $this->load->view('client/contact_profile',$contact_info);

	 }

	 

	 public function activity($id = NULL)

	 {

	$task_info['contactInfo'] = $this->person->get_by_id($id);

	$task_info['taskInfo'] = $this->tasks->get_by_contact($id);

	$this->load->view('client/activity',$task_info);

	 }

	 

	  public function invoices($id = NULL)

	 {

	 $invoice_info['contactInfo'] = $this->person->get_by_id($id);

	$invoice_info['invoiceInfo'] = $this->invoice->get_by_contact($id);

	$this->load->view('client/invoices',$invoice_info);

	 }

	 

	  public function transaction($id = NULL)

	 {

	 $contact_info['contactInfo'] = $this->tasks->get_by_contact($id);

	$this->load->view('client/transaction',$contact_info);

	 }

	 

	  public function mailme($id = NULL)

	 {

	 $clientEmail['client_email'] = $this->person->get_by_id($id);

	 $this->load->view('client/email',$clientEmail);

	 }



public function sendemail()

	 {
	$this->load->library('email');
	
/*$config['protocol'] = 'sendmail';
$config['mailpath'] = '/usr/sbin/sendmail';
$config['charset'] = 'iso-8859-1';
$config['wordwrap'] = TRUE;

$this->email->initialize($config);



$this->email->from('info@billingbull.com', 'Jewel Rana');
$this->email->to(set_value($this->input->post('email_address')));
$this->email->cc('meneva92@gmail.com');
$this->email->bcc('jewel@redorangeid.nl');

$this->email->subject($this->input->post('email_subject'));
$this->email->message($this->input->post('email_details'));

$this->email->send();*/
$this->email->from('info@billingbull.com', 'Jewel Rana');
    $this->email->to($this->input->post('email_address'));
    $this->email->cc('meneva92@gmail.com'); 
    $this->email->subject('Your Subject');
    $this->email->message('Your Message');
   // $this->email->attach('/path/to/file1.png'); // attach file
   // $this->email->attach('/path/to/file2.pdf');
    if ($this->email->send())
        echo "Mail Sent!";
    else
        echo "There is error in sending mail!";


	
	 }

	 

	 public function contact_update($id = NULL)

	 {

       $client_info['myInfo'] = $this->person->get_by_id($id);
      $client_info['pubsInfo'] = $this->pubs->get_all();
	 $this->load->view('client/contact_update',$client_info);

	 

	 }

	 

	  public function contact_upload($id = NULL)

	 {

       $client_info['myInfo'] = $this->person->get_by_id($id);

	 $this->load->view('client/contact_upload',$client_info);

	 

	 }
	 
	 
public function contact_avatar($id = NULL)
 {
 
header('Content-Type: application/json');
//ini_set('memory_limit','16M');

$error					= false;

$absolutedir			= dirname(__FILE__);
//$absolutedir = str_replace('\controllers','',$absolutedir);
$upload_dir = str_replace('application/controllers','',$absolutedir);
$dir					= '/uploads/contact/';
$serverdir				= $absolutedir.$dir;

$tmp					= explode(',',$_POST['data']);
$imgdata 				= base64_decode($tmp[1]);

$endx = explode('.',$_POST['name']);
$endxx = end($endx);
$extension				= strtolower($endxx);
$filename				= substr($_POST['name'],0,-(strlen($extension) + 1)).'.'.substr(sha1(time()),0,6).'-'.$id.'.'.$extension;

$handle					= fopen($serverdir.$filename,'w');
fwrite($handle, $imgdata);
fclose($handle);

$imagePath = $upload_dir.'uploads/contact/';
rename($serverdir.$filename,  $imagePath.$filename);


$response = array(
		"status" 		=> "success",
		"url" 			=> $dir.$filename.'?'.time(), //added the time to force update when editting multiple times
		"filename" 		=> $filename
);


if (!empty($_POST['original'])) {
	$tmp				= explode(',',$_POST['original']);
	$originaldata		= base64_decode($tmp[1]);
	$original			= substr($_POST['name'],0,-(strlen($extension) + 1)).'.'.substr(sha1(time()),0,6).'.original.'.$extension;

	$handle				= fopen($serverdir.$original,'w');
	fwrite($handle, $originaldata);
	fclose($handle);
	
	$response['original']	= $original;
}

$existing_photo = $this->person->get_by_id($id);
if(!empty($existing_photo->image_id)) {
 unlink($serverdir.$existing_photo->image_id ); // first remove the existing image....
   }
$myAvatar = array('image_id'=>$filename);
$this->person->update(array('id' => $id), $myAvatar);


print json_encode($response);
 
 
 }	 
	 

public function imgCrop($id = NULL)

  {
/*
*	!!! THIS IS JUST AN EXAMPLE !!!, PLEASE USE ImageMagick or some other quality image processing libraries
*/
$imgUrl = $_POST['imgUrl'];
// original sizes
$imgInitW = $_POST['imgInitW'];
$imgInitH = $_POST['imgInitH'];
// resized sizes
$imgW = $_POST['imgW'];
$imgH = $_POST['imgH'];
// offsets
$imgY1 = $_POST['imgY1'];
$imgX1 = $_POST['imgX1'];
// crop box
$cropW = $_POST['cropW'];
$cropH = $_POST['cropH'];
// rotation angle
$angle = $_POST['rotation'];

$jpeg_quality = 100;

$output_filename = "uploads/".time().'-'.$id;
$myphoto = str_replace('uploads/','',$output_filename);
// uncomment line below to save the cropped image in the same location as the original image.
//$output_filename = dirname($imgUrl). "/croppedImg_".rand();

$what = getimagesize($imgUrl);

switch(strtolower($what['mime']))
{
    case 'image/png':
        $img_r = imagecreatefrompng($imgUrl);
		$source_image = imagecreatefrompng($imgUrl);
		$type = '.png';
        break;
    case 'image/jpeg':
        $img_r = imagecreatefromjpeg($imgUrl);
		$source_image = imagecreatefromjpeg($imgUrl);
		error_log("jpg");
		$type = '.jpeg';
        break;
    case 'image/gif':
        $img_r = imagecreatefromgif($imgUrl);
		$source_image = imagecreatefromgif($imgUrl);
		$type = '.gif';
        break;
    default: die('image type not supported');
}


//Check write Access to Directory

if(!is_writable(dirname($output_filename))){
	$response = Array(
	    "status" => 'error',
	    "message" => 'Can`t write cropped File'
    );	
}else{

    // resize the original image to size of editor
    $resizedImage = imagecreatetruecolor($imgW, $imgH);
	imagecopyresampled($resizedImage, $source_image, 0, 0, 0, 0, $imgW, $imgH, $imgInitW, $imgInitH);
    // rotate the rezized image
    $rotated_image = imagerotate($resizedImage, -$angle, 0);
    // find new width & height of rotated image
    $rotated_width = imagesx($rotated_image);
    $rotated_height = imagesy($rotated_image);
    // diff between rotated & original sizes
    $dx = $rotated_width - $imgW;
    $dy = $rotated_height - $imgH;
    // crop rotated image to fit into original rezized rectangle
	$cropped_rotated_image = imagecreatetruecolor($imgW, $imgH);
	imagecolortransparent($cropped_rotated_image, imagecolorallocate($cropped_rotated_image, 0, 0, 0));
	imagecopyresampled($cropped_rotated_image, $rotated_image, 0, 0, $dx / 2, $dy / 2, $imgW, $imgH, $imgW, $imgH);
	// crop image into selected area
	$final_image = imagecreatetruecolor($cropW, $cropH);
	imagecolortransparent($final_image, imagecolorallocate($final_image, 0, 0, 0));
	imagecopyresampled($final_image, $cropped_rotated_image, 0, 0, $imgX1, $imgY1, $cropW, $cropH, $cropW, $cropH);
	// finally output png image
	//imagepng($final_image, $output_filename.$type, $png_quality);
	imagejpeg($final_image, $output_filename.$type, $jpeg_quality);
	$cropImg = base_url().$output_filename.$type;
	$response = Array(
	    "status" => 'success',
	    "url" => $cropImg
    );
}
$imagePath = "uploads/";
$existing_photo = $this->person->get_by_id($id);	
 unlink($imagePath.$existing_photo->image_id ); // first remove the existing image....

$datai = array('image_id' => $myphoto.$type);
$this->person->update(array('id' => $id), $datai);
print json_encode($response);   

  
  }

	

	public function fileUpload($id = NULL)

           {

    $imagePath = "uploads/";
	$existing_photo = $this->person->get_by_id($id);	
		   
		   unlink($imagePath.$existing_photo->image_id ); // first remove the existing image....

	$allowedExts = array("gif", "jpeg", "jpg", "png", "GIF", "JPEG", "JPG", "PNG");
	$temp = explode(".", $_FILES["img"]["name"]);
	$extension = end($temp);
	
	//Check write Access to Directory

	if(!is_writable($imagePath)){
		$response = Array(
			"status" => 'error',
			"message" => 'Can`t upload File; no write Access'
		);
		print json_encode($response);
		return;
	}
	
	if ( in_array($extension, $allowedExts))
	  {
	  if ($_FILES["img"]["error"] > 0)
		{
			 $response = array(
				"status" => 'error',
				"message" => 'ERROR Return Code: '. $_FILES["img"]["error"],
			);			
		}
	  else
		{
			
	      $filename = $_FILES["img"]["tmp_name"];
		  list($width, $height) = getimagesize( $filename );

 move_uploaded_file($filename,  $imagePath . $_FILES["img"]["name"]);
		  
		  

		  $response = array(
			"status" => 'success',
			"url" => $imagePath.$_FILES["img"]["name"],
			"width" => $width,
			"height" => $height
		  );
		  
		  
		  
		}
	  }
	else
	  {
	   $response = array(
			"status" => 'error',
			"message" => 'something went wrong, most likely file is to large for upload. check upload_max_filesize, post_max_size and memory_limit in you php.ini',
		);
	  }
	  
	  print json_encode($response);	
	  
	 

           }



	

	public function add_client()

	 {


   $data['pubsInfo'] = $this->pubs->get_all();
	 $this->load->view('client/add_client',$data);

	 

	 }



public function update_note($id = NULL)

	 {

	  $data = array('note' => $this->input->post('note_details'));



	 $this->person->update(array('id' => $id), $data);

	 

	 }



	public function ajax_update()

	{

		$this->_validate();

		$data = array(

				'name' => $this->input->post('name'),

				'company' => $this->input->post('company'),

				'tax_id' => $this->input->post('tax_id'),

				'email' => $this->input->post('email'),

				'phone' => $this->input->post('phone'),

				'mobile' => $this->input->post('mobile'),

				'fax' => $this->input->post('fax'),

				'address' => $this->input->post('address'),

				'city' => $this->input->post('city'),

				'state' => $this->input->post('state_region'),

				'zip_code' => $this->input->post('zip_code'),

				'country' => $this->input->post('country'),

				'website' => $this->input->post('website'),
				
				'skypeID' => $this->input->post('skypeID'),
                'contact_category' => $this->input->post('contact_category'),
				'publication_id' => $this->input->post('publication_id'),
	

			);

			

				

		$this->person->update(array('id' => $this->input->post('id')), $data);



		echo json_encode(array("status" => TRUE));

	}



	public function ajax_delete($id)

	{

	  

		$this->person->delete_by_id($id);

		echo json_encode(array("status" => TRUE));

	}





	private function _validate()

	{

		$data = array();

		$data['error_string'] = array();

		$data['inputerror'] = array();

		$data['status'] = TRUE;

    // $this->form_validation->set_rules('email', 'Email', 'required|valid_email');

     if(($this->input->post('contact_category') == '1') && ($this->input->post('company') == ''))

		{

			$data['inputerror'][] = 'company';

			$data['error_string'][] = 'Company Name is required';

			$data['status'] = FALSE;

		}
		
		 if(($this->input->post('contact_category') == '1') && ($this->input->post('address') == ''))

		{

			$data['inputerror'][] = 'address';

			$data['error_string'][] = 'Address is required';

			$data['status'] = FALSE;

		}



		if($this->input->post('name') == '' || !preg_match('/[^a-z_\-]/i', $this->input->post('name')))

		{

			$data['inputerror'][] = 'name';

			$data['error_string'][] = 'Invalid Name';

			$data['status'] = FALSE;

		}



		



		if($this->input->post('email') == '' || !filter_var($this->input->post('email'), FILTER_VALIDATE_EMAIL) )
		

		{

			$data['inputerror'][] = 'email';

			$data['error_string'][] = 'invalid Email address';

			$data['status'] = FALSE;

		}



		if($this->input->post('phone') == '' || !is_numeric($this->input->post('phone')))

		{

			$data['inputerror'][] = 'phone';

			$data['error_string'][] = 'Invalid phone no.';

			$data['status'] = FALSE;

		}
		
		if($this->input->post('mobile') <> '' && !is_numeric($this->input->post('mobile')))

		{

			$data['inputerror'][] = 'mobile';

			$data['error_string'][] = 'Invalid mobile no.';

			$data['status'] = FALSE;

		}
		
	if($this->input->post('fax') <> '' && !is_numeric($this->input->post('fax')))

		{

			$data['inputerror'][] = 'fax';

			$data['error_string'][] = 'Invalid fax no.';

			$data['status'] = FALSE;

		}

if($this->input->post('city') == '' || (ctype_alpha(str_replace(' ', '', $this->input->post('city'))) === false))

		{

			$data['inputerror'][] = 'city';

			$data['error_string'][] = 'Invalid City name';

			$data['status'] = FALSE;

		}	

if($this->input->post('zip_code') <> '' && !is_numeric($this->input->post('zip_code')))

		{

			$data['inputerror'][] = 'zip_code';

			$data['error_string'][] = 'Invalid zip code';

			$data['status'] = FALSE;

		}
	

			
if($this->input->post('country') == '')

		{

			$data['inputerror'][] = 'country';

			$data['error_string'][] = 'Please Choose your country';

			$data['status'] = FALSE;

		}		


		if($data['status'] === FALSE)

		{

			echo json_encode($data);

			exit();

		}

	}

	

	



}

