<?php

defined('BASEPATH') OR exit('No direct script access allowed');



class Subscriber extends CI_Controller {



	public function __construct()

	{

		parent::__construct();

		 if(empty($this->session->userdata('id')) ) {
      
		 
            $this->session->set_flashdata('flash_data', 'You don\'t have access!');
            redirect('login');
			 
        }

		$this->load->model('subscriber_model','person');
        $this->load->model('distributionMethod_model','distribute');
		$this->load->model('subscriberMeta_model','submeta');
		$this->load->model('subscriberActivity_model','activity');
		$this->load->model('publication_model','pubs');

		// $this->load->model('SubscriptionGroup_model','groupss');
		$this->load->model('subscriptionType_model','type');
		$this->load->model('subscriptionGroup_model','group');
		$this->load->model('SubscriberLists_model','scrlists');
		$this->load->model('SubscriberTags_model','tags');
		$this->load->model('interestGroup_model','interests');
		$this->load->model('UserPrivileges_model','privilege');
		$this->load->helper('url'); // to load header footer or anyother url related links....
		$this->load->library('upload'); // to upload image
		$this->load->helper('directory'); //load directory helper ot show client image from upload folder 
		$this->load->library('form_validation');
	}



	public function index()

	{

	$mydata['pubsInfo'] = $this->pubs->get_all();

		$this->load->view('subscriber/all_subscriber',$mydata);

	}

	public function ajax_list($publication = NULL)

	{

	$list = $this->person->get_datatables($publication);
	$data = array();

		$no = $_POST['start'];

		foreach ($list as $person) {

			$no++;

			$row = array();
			
			

			if($person->image_id) { $row[] = '<div class="profile-userpic"><img src="'.base_url()."uploads/contact/".$person->image_id.'" alt="" class="img-responsive" style="max-width:50px;"></div> '; }
			if(empty($person->image_id)) { $row[] = '<div class="profile-userpic"><img src="'.base_url()."assets/images/placeholder.png".'" alt="" class="img-responsive" style="max-width:50px;"></div> '; }
			

			$row[] = $person->name;
			
			if($person->company) { $row[] = $person->company; } else { $row[] = 'Individual'; }
			$row[] = $person->email;
			$row[] = $person->phone;
			$row[] = $person->mobile;			
			$row[] = '<a class="btn btn-icon-only yellow" href="'.base_url().'client/view/'.$person->id.'"><i class="fa fa-eye"></i></a>
			<a class="btn btn-icon-only green" href="'.base_url().'client/view/'.$person->id.'edit">
			<i class="fa fa-edit"></i></a>
			<a class="btn btn-icon-only red" href="javascript:void()" title="Edit" onclick="delete_contact('."'".$person->id."'".')">
			<i class="fa fa-trash"></i></a> ';
			$data[] = $row;
		}

		$output = array(

						"draw" => $_POST['draw'],
						"recordsTotal" => $this->person->count_all(),
						"recordsFiltered" => $this->person->count_filtered(),
						"data" => $data,

						

				);

		//output to json format

		echo json_encode($output);

	}


public function custom_search($pub,$usr,$group)
	 {
	$myname_query = $this->db->get_where('users',array('id'=>$this->session->userdata('id')));
	$myname = $myname_query->row();
	$usr = $myname->id;

	$group = $myname->group_id;
	//var_dump($group);
	 //$data = $this->input->post('publication_id');
	 	//var_dump( $pub);
	 $mydata['pubsInfo'] = $this->pubs->get_all();
	 $mydata['searchInfo'] = $this->person->custom_search_result($pub,$usr,$group);
         $mydata['pubID'] = $pub;
        $mydata['totalPaid'] = $this->person->total_paid_subscriber($pub);
        $mydata['totalComplementary'] = $this->person->total_complementary_subscriber($pub);
        $mydata['totalActive'] = $this->person->totalSubscriber($pub);
        $mydata['totalExpired'] = $this->person->totalExpiredSubscriber($pub);


        if($group == 1) {
	    $this->load->view('subscriber/subscriber_by_publication_filter',$mydata);
		}else{
		$this->load->view('subscriber/subscriber_by_publication',$mydata);
		}

	//echo json_encode(array("status" => TRUE));
	 }


public function cat_type_subscriber($pub,$cat_id,$type_id,$usr,$group)
	 {
		$myname_query = $this->db->get_where('users',array('id'=>$this->session->userdata('id')));
		$myname = $myname_query->row();
		$usr = $myname->id;

		$group = $myname->group_id;
	 
	 //var_dump("$cat_id");
	 //$data = $this->input->post('publication_id');
	 $mydata['pubsInfo'] = $this->pubs->get_all();
	 if($cat_id == '0' ||  $type_id == '0'){
	 $mydata['searchInfo'] = $this->person->custom_search_result_cat_type1($pub,$cat_id,$type_id,$usr,$group);
	}
	else {
		$mydata['searchInfo'] = $this->person->custom_search_result_cat_type($pub,$cat_id,$type_id,$usr,$group);
	}
	
	 //var_dump($mydata['searchInfo']);
     $mydata['pubID'] = $pub;
       
        
	 $this->load->view('subscriber/subscriber_by_publication_type_cat',$mydata);
	//echo json_encode(array("status" => TRUE));
	 }



//////////////// Intersest/Working Group/Area Search /////////////////////////

public function custom_search2($pub)
	 {

	 $mydata['pubsInfo'] = $this->pubs->get_all();
	 $mydata['searchInfo2'] = $this->interests->custom_search_result2($pub);
     $mydata['pubID'] = $pub;

        
	 $this->load->view('subscriber/interest_group_list',$mydata);
	 }



//--------------------------------------------------------//
	 //       Intersest/Working Group/Area        //
//--------------------------------------------------------//


public function interest_group()
	{
	$this->load->model('Publication_model','pubs');
	$data['pubsInfo'] = $this->pubs->get_all();
	$this->load->view('subscriber/interest_group_by_publication',$data);
	}
public function interest_group_list()
	{
		$this->load->model('interestGroup_model','interests');
		$data['groupInfo'] = $this->interests->get_all();
		$this->load->view('subscriber/interest_group_list', $data);
	}
public function add_interest_group()
	     {
	    $this->load->model('interestGroup_model','interest');
		$data = array(
		       'publication_id' => $this->input->post('publication_id'),
				'title' => $this->input->post('title'),
				'description' => $this->input->post('description')
			);
		$insert = $this->interest->save($data);
		echo json_encode(array("status" => TRUE));
	     }
public function edit_interest_group($id)
	{
 $this->load->model('interestGroup_model','interest');
		$group_info = $this->interest->get_by_id($id);
		$data = array('id'=>$group_info->id, 

                        'publication_id' => $group_info->publication_id,
		               'title'=>$group_info->title,
					   'description'=>$group_info->description
					  );
		echo json_encode($data);
	}
public function update_interest_group()
	     {
	    $this->load->model('interestGroup_model','interest');
		$data = array(
		        'publication_id' => $this->input->post('publication_id'),
				'title' => $this->input->post('title'),
				'description' => $this->input->post('description')
			);
		$this->interest->update(array('id' => $this->input->post('id')), $data);
		echo json_encode(array("status" => TRUE));
	     }	

public function delete_interest_group($id)
{
 $this->load->model('interestGroup_model','interest');
		$this->interest->delete_by_id($id);
		echo json_encode(array("status" => TRUE));
	}  



////////////////  Subscription Group Search    /////////////////////////

public function custom_search1($pub)
	{

	$mydata['pubsInfo'] = $this->pubs->get_all();
	$mydata['searchInfo1'] = $this->group->custom_search_result1($pub);
	$mydata['pubID'] = $pub;
	$this->load->view('subscriber/subscription_group_list',$mydata);
	}


public function subscription_group()
	{
	$this->load->model('Publication_model','pubs');
	$data['pubsInfo'] = $this->pubs->get_all();
	$this->load->view('subscriber/subcriber_group_by_publication',$data);
	}
public function subscription_group_list()
	{
	$this->load->model('SubscriptionGroup_model','groups');
	$data['groupInfo'] = $this->groups->get_all();
	$this->load->view('subscriber/subscription_group_list', $data);
	}
public function add_subscription_group()

	{
	// $this->_validate_groups();
	$this->load->model('SubscriptionGroup_model','groups');
	$data = array(
	    'publication_id' => $this->input->post('publication_id'),
		'title' => $this->input->post('title'),
		'description' => $this->input->post('description')
	);
	$insert = $this->groups->save($data);
	echo json_encode(array("status" => TRUE));
	}
public function edit_subscription_group($id)
	{
	$this->load->model('SubscriptionGroup_model','groups');
		$group_info = $this->groups->get_by_id($id);
		$data = array('id'=>$group_info->id, 
			'publication_id' => $group_info->publication_id,
			'title'=>$group_info->title,
			'description'=>$group_info->description
					  );
		echo json_encode($data);
	}

public function update_subscription_group()
	     {
	    // $this->_validate_groups();
	    $this->load->model('SubscriptionGroup_model','groups');
		$data = array(
		 'publication_id' => $this->input->post('publication_id'),
				'title' => $this->input->post('title'),
				'description' => $this->input->post('description')
			);

		$this->groups->update(array('id' => $this->input->post('id')), $data);

		echo json_encode(array("status" => TRUE));
	     }	

public function delete_subscription_group($id)

	{

 $this->load->model('SubscriptionGroup_model','groups');
		$this->groups->delete_by_id($id);
		echo json_encode(array("status" => TRUE));
	}  

//////////////// End Subscriber Group /////////////////////////




////////////////  Subscription Tags Search    /////////////////////////

public function custom_search3($pub)
	{

	$mydata['pubsInfo'] = $this->pubs->get_all();
	$mydata['searchInfo3'] = $this->tags->custom_search_result3($pub);
	$mydata['pubID'] = $pub;
	$this->load->view('subscriber/subscriber_tags_list',$mydata);
	}


public function subscriber_tags()
	{
	$this->load->model('Publication_model','pubs');
	$data['pubsInfo'] = $this->pubs->get_all();
	$this->load->view('subscriber/subscriber_tags_by_publication',$data);
	}
public function subscriber_tags_list()
	{
	$this->load->model('SubscriberTags_model','tags');
	$data['tagInfo'] = $this->tags->get_all();
	$this->load->view('subscriber/subscriber_tags_list', $data);
	}
public function add_subscriber_tags()

	{
	// $this->_validate_groups();
	$this->load->model('SubscriberTags_model','tags');
	$data = array(
	    'publication_id' => $this->input->post('publication_id'),
		'title' => $this->input->post('title'),
		'description' => $this->input->post('description')
	);
	$insert = $this->tags->save($data);
	echo json_encode(array("status" => TRUE));
	}

	

public function edit_subscriber_tags($id)
	{
	$this->load->model('SubscriberTags_model','tags');
		$tags_info = $this->tags->get_by_id($id);
		$data = array('id'=>$tags_info->id, 
			'publication_id' => $tag_info->publication_id,
			'title'=>$tags_info->title,
			'description'=>$tags_info->description
					  );
		echo json_encode($data);
	}

public function update_subscriber_tags()

	     {

	    // $this->_validate_scrlists();
	    $this->load->model('SubscriberTags_model','tags');
		$data = array(
		 'publication_id' => $this->input->post('publication_id'),
				'title' => $this->input->post('title'),
				'description' => $this->input->post('description')
			);
		$this->scrlists->update(array('id' => $this->input->post('id')), $data);
		echo json_encode(array("status" => TRUE));
	     }	
public function delete_subscriber_tags($id)
	{

 $this->load->model('SubscriberTags_model','tags');
		$this->tags->delete_by_id($id);
		echo json_encode(array("status" => TRUE));
	}  


//////////////// End Subscriber Tags /////////////////////////


///////////////  Subscription Lists    /////////////////////////

public function custom_search4($pub)
	{

	$mydata['pubsInfo'] = $this->pubs->get_all();
	$mydata['searchInfo4'] = $this->scrlists->custom_search_result4($pub);
	$mydata['pubID'] = $pub;
	$this->load->view('subscriber/subscription_lists_list',$mydata);
	}


public function subscriber_lists()
	{
	$this->load->model('Publication_model','pubs');
	$data['pubsInfo'] = $this->pubs->get_all();
	$this->load->view('subscriber/subcriber_lists_by_publication',$data);
	}
public function subscriber_lists_list()
	{
	$this->load->model('SubscriberLists_model','scrlists');
	$data['groupInfo'] = $this->scrlists->get_all();
	$this->load->view('subscriber/subscription_lists_list', $data);
	}
public function add_subscriber_lists()

	{
	// $this->_validate_scrlists();
	$this->load->model('SubscriberLists_model','scrlists');
	$data = array(
	    'publication_id' => $this->input->post('publication_id'),
		'title' => $this->input->post('title'),
		'description' => $this->input->post('description')
	);
	$insert = $this->scrlists->save($data);
	echo json_encode(array("status" => TRUE));
	}
public function edit_subscriber_lists($id)
	{
	$this->load->model('SubscriberLists_model','scrlists');
		$group_info = $this->scrlists->get_by_id($id);
		$data = array('id'=>$group_info->id, 
			'publication_id' => $group_info->publication_id,
			'title'=>$group_info->title,
			'description'=>$group_info->description
					  );
		echo json_encode($data);
	}

public function update_subscriber_lists()

	     {

	    // $this->_validate_scrlists();
	    $this->load->model('SubscriberLists_model','scrlists');
		$data = array(
		 'publication_id' => $this->input->post('publication_id'),
				'title' => $this->input->post('title'),
				'description' => $this->input->post('description')
			);
		$this->scrlists->update(array('id' => $this->input->post('id')), $data);
		echo json_encode(array("status" => TRUE));
	     }	

public function delete_subscriber_lists($id)
	{
 $this->load->model('SubscriberLists_model','scrlists');
		$this->scrlists->delete_by_id($id);
		echo json_encode(array("status" => TRUE));
	}  

//////////////// End Subscriber Lists /////////////////////////

	
public function active_subscriber($pub)
	 {
	 
	 //$data = $this->input->post('publication_id');
	 $mydata['pubsInfo'] = $this->pubs->get_all();
	 $mydata['searchInfo'] = $this->person->active_subscriber_result($pub);
         $mydata['pubID'] = $pub;
	 $this->load->view('subscriber/active_subscriber',$mydata);
	//echo json_encode(array("status" => TRUE));
	 }

public function closed_subscriber($pub)
	 {
	 
	 //$data = $this->input->post('publication_id');
	 $mydata['pubsInfo'] = $this->pubs->get_all();
	 $mydata['searchInfo'] = $this->person->closed_subscriber_result($pub);
         $mydata['pubID'] = $pub;
	 $this->load->view('subscriber/closed_subscriber',$mydata);
	//echo json_encode(array("status" => TRUE));
	 }

public function pending_subscriber($pub)
	 {
	 
	 //$data = $this->input->post('publication_id');
	 $mydata['pubsInfo'] = $this->pubs->get_all();
	 $mydata['searchInfo'] = $this->person->pending_subscriber_result($pub);
         $mydata['pubID'] = $pub;
	 $this->load->view('subscriber/pending_subscriber',$mydata);
	//echo json_encode(array("status" => TRUE));
	 }

public function expired_subscriber($pub,$duration)
	 {
	 
	 $data['pub_id'] = $pub;
	 $data['myduration'] = $duration;
	 $this->load->view('subscriber/expired_in_duration',$data);
	//echo json_encode(array("status" => TRUE));
	 }

public function all_expired($pub)
	 {
	 
	 $data['pub_id'] = $pub;
	 //$data['myduration'] = $duration;
	 $this->load->view('subscriber/all_expired',$data);
	//echo json_encode(array("status" => TRUE));
	 }
	 
public function paid_subscriber($pub)
	 {
	 
	 //$data = $this->input->post('publication_id');
	 $mydata['pubsInfo'] = $this->pubs->get_all();
	 $mydata['searchInfo'] = $this->person->paid_subscriber_result($pub);
         $mydata['pubID'] = $pub;
	 $this->load->view('subscriber/paid_subscriber',$mydata);
	//echo json_encode(array("status" => TRUE));
	 }	 
public function complementary_subscriber($pub)
	 {
	 
	 //$data = $this->input->post('publication_id');
	 $mydata['pubsInfo'] = $this->pubs->get_all();
	 $mydata['searchInfo'] = $this->person->complementary_subscriber_result($pub);
         $mydata['pubID'] = $pub;
	 $this->load->view('subscriber/complementary_subscriber',$mydata);
	//echo json_encode(array("status" => TRUE));
	 }
	 
	 
public function statistics($start,$end)
  {
   
 //$subs = $this->person->subscriber_statistics($start,$end); 
 $data['subs_statistics'] = $this->person->subscriber_statistics($start,$end); 
  $data['start_date'] = $start;
  $data['end_date'] = $end;
 
 $this->load->view('dashboard/subscriber_transaction',$data);
  
  }	 
	 
	 
	 
	 
	 

 public function ajax_edit($id)

	{

		$contact_info = $this->person->get_by_id($id);

		//$data->dob = ($data->dob == '0000-00-00') ? '' : $data->dob; // if 0000-00-00 set tu empty for datepicker compatibility

		

		

		$data = array('id'=>$contact_info->id, 

		             'name' => $this->input->post('name'),
				'occupation' => $this->input->post('occupation'),
				'designation' => $this->input->post('designation'),
				'company' => $this->input->post('company'),
				'email' => $this->input->post('email'),
				'phone' => $this->input->post('phone'),
				'alternative_phone' => $this->input->post('alternative_phone'),
				'date_of_birth' => $this->input->post('date_of_birth'),
				
                                 'house' => $this->input->post('house'),
                                 'area' => $this->input->post('area'),
				'state' => $this->input->post('state'),
                                 'city' => $this->input->post('city'),
				'zip' => $this->input->post('zip'),
				'country' => $this->input->post('country'),

				'category' => $this->input->post('category'),
				'type' => $this->input->post('type'),
				'tags' => $this->input->post('tags'),
				'scrlists' => $this->input->post('scrlists'),
                               // 'fee' => $this->input->post('fee'),
				'start_date' => $this->input->post('start_date'),
                                 'group' => $this->input->post('group'),
                                  'interest' => $this->input->post('interest'),
                                  'publication_id' => $this->input->post('publication_id'),
								  'status' => $this->input->post('status'),
                                  'distribution_method' => $this->input->post('distribution_method'),
					   

					  );

		

		

		echo json_encode($data);

	}



	public function ajax_add()

	{
$myprev = $this->privilege->get_by_userid($this->session->userdata('id'));
		$valid = $myprev->subscriber_crud;
		$this->_validate();
		$valid1 = $myprev->user_id;

		$data = array(

				'name' => $this->input->post('name'),
				'occupation' => $this->input->post('occupation'),
				'designation' => $this->input->post('designation'),
				'company' => $this->input->post('company'),
				'email' => $this->input->post('email'),
				'phone' => $this->input->post('phone'),
				'alternative_phone' => $this->input->post('alternative_phone'),
				'date_of_birth' => $this->input->post('date_of_birth'),
				
                                 'house' => $this->input->post('house'),
                                 'area' => $this->input->post('area'),
				'state' => $this->input->post('state'),
                                 'city' => $this->input->post('city'),
				'zip' => $this->input->post('zip'),
				'country' => $this->input->post('country'),

				'category' => $this->input->post('category'),
				'type' => $this->input->post('type'),
				'tags' => $this->input->post('tags'),
				'tags_2' => $this->input->post('tags_2'),
				'tags_3' => $this->input->post('tags_3'),
				'scrlists' => $this->input->post('scrlists'),
				'user_id' => $valid1,
                              //  'fee' => $this->input->post('fee'),
				'start_date' => $this->input->post('start_date'),
                                 'group' => $this->input->post('group'),
                                  'interest' => $this->input->post('interest'),
                                  'tags' => $this->input->post('tags'),
                                  'scrlists' => $this->input->post('scrlists'),
                                  'publication_id' => $this->input->post('publication_id'),
				 'status' => $this->input->post('status'),
                                  'distribution_method' => $this->input->post('distribution_method'),
				
			);

		$insert = $this->person->save($data); // execute the save function from user model

	

//// for billing address///////////////////////////

$billing_address = array(                'billing_house' => $this->input->post('billing_house'),
                                 'billing_area' => $this->input->post('billing_area'),
				'billing_state' => $this->input->post('billing_state'),
                                 'billing_city' => $this->input->post('billing_city'),
				'billing_zip' => $this->input->post('billing_zip'),
 				'billing_country' => $this->input->post('billing_country'),
	
			);
$meta_value = json_encode($billing_address);

$subscriber_info = array('subscriber_id'=>$insert, 'meta_key'=>'billing_address','meta_value'=>$meta_value);

$insert_billing = $this->submeta->save($subscriber_info); // execute the save function from user model
///////////////////////////////////////////////

//// for subscription history ///////////////////

$subscription_info = array(      
                                 'category' => $this->input->post('category'),
                                 'type' => $this->input->post('type'),
                                 //'fee' => $this->input->post('fee'),
				
                                 
			);
$subscription_value = json_encode($subscription_info);

$subscriber_metainfo = array('subscriber_id'=>$insert, 'meta_key'=>'subscription', 'start_date' => $this->input->post('start_date'),'meta_value'=>$subscription_value);

$insert_subscription_meta = $this->submeta->save($subscriber_metainfo); // execute the save function from user model



////////////////////////////////

echo json_encode(array('id'=>$insert,"status" => TRUE));

	}

	

	public function view($id=NULL)

	 {
          $myprev = $this->privilege->get_by_userid($this->session->userdata('id'));
	 $valid = $myprev->subscriber_crud;
	 if($valid == '0')  {
		 
            $this->session->set_flashdata('flash_data', 'You don\'t have access!');
            redirect('dashboard/no_access');
			//exit();
			 
        }
		else {
	 $contact_info['subscriberInfo'] = $this->person->get_by_id($id);

	 

	 $this->load->view('subscriber/subscriber_details',$contact_info);
         }
	 }

	 public function summary($id=NULL)

	 {

	 $contact_info['subscriberInfo'] = $this->person->get_by_id($id);

	 

	 $this->load->view('subscriber/subscriber_summary',$contact_info);

	 }
public function activity($id=NULL)

	 {
         $contact_info['subscriberInfo'] = $this->person->get_by_id($id);
	 $contact_info['activityInfo'] = $this->activity->get_by_subscriber($id);

	 

	 $this->load->view('subscriber/subscriber_activity',$contact_info);

	 }

public function renew_subscription($id=NULL)

	 {
               
	 $contact_info['subscriberInfo'] = $this->person->get_by_id($id);
          //$contact_info['subscriptionType'] = $this->type->get_all();
	 

	 $this->load->view('subscriber/renew_subscription',$contact_info);

	 }

public function renew_process()

	 {
         $this->_validate_renew();

	$subscription_info = array( 
                                 'category' => $this->input->post('category'),
                                 'type' => $this->input->post('type'),
                                // 'fee' => $this->input->post('fee'),
                                 'start_date' => $this->input->post('start_date'),
				
                                 
			);
	

$this->person->update(array('id' => $this->input->post('subscriber_id')), $subscription_info);			
			
$subscription_value = json_encode($subscription_info);

$subscriber_metainfo = array('subscriber_id'=>$this->input->post('subscriber_id'), 'meta_key'=>'renew', 'start_date' => $this->input->post('start_date'),'meta_value'=>$subscription_value);

$insert_subscription_meta = $this->submeta->save($subscriber_metainfo); // execute the save function from user model

echo json_encode(array('id'=>$insert_subscription_meta,"status" => TRUE));
	 }

public function upgrade_process()

	 {
 
$data = array('category' => $this->input->post('category'),
                                 'type' => $this->input->post('type'),
                                // 'fee' => $this->input->post('fee'),
                                 'start_date' => $this->input->post('start_date'),
				
	

			);
			

$this->person->update(array('id' => $this->input->post('subscriber_id')), $data);

 /*
	$subscription_info = array( 
                                 'category' => $this->input->post('category'),
                                 'type' => $this->input->post('type'),
                                 'fee' => $this->input->post('fee'),
				
                                 
			);
			*/
$subscription_value = json_encode($data);

$subscriber_metainfo = array('subscriber_id'=>$this->input->post('subscriber_id'), 'meta_key'=>'upgrade', 'start_date' => $this->input->post('start_date'),'meta_value'=>$subscription_value);

$insert_subscription_meta = $this->submeta->save($subscriber_metainfo); // execute the save function from user model

echo json_encode(array('id'=>$insert_subscription_meta,"status" => TRUE));
	 }

public function subscription_history($id=NULL)

	 {
        $sub_info['newInfo'] = $this->submeta->get_by_newSubscription($id);
	 $sub_info['subscriberInfo'] = $this->submeta->get_by_subid($id);
         $sub_info['upgradeInfo'] = $this->submeta->get_by_upgradeid($id);
	 $sub_info['myInfo'] = $this->person->get_by_id($id);

	 $this->load->view('subscriber/subscription_history',$sub_info);

	 }

public function close_subscriber($id=NULL)

	{
	$data = array('status' => 'closed');
    $this->person->update(array('id' => $id), $data);
   echo json_encode(array("status" => TRUE));

	}

	public function activate_subscriber($id=NULL)

	{
	$data = array('status' => 'active');
    $this->person->update(array('id' => $id), $data);
   echo json_encode(array("status" => TRUE));

	}

	 

	 public function subscriber_update($id = NULL)
	 {
		$this->load->model('SubscriberLists_model','scrlists');
		$this->load->model('SubscriberTags_model','tags');

		$sub_info['myInfo'] = $this->person->get_by_id($id);
		$sub_info['pubsInfo'] = $this->pubs->get_all();
		$sub_info['groupInfo'] = $this->group->get_all();
		$sub_info['typeInfo'] = $this->type->get_all();
		$sub_info['interestInfo'] = $this->interests->get_all();

		$sub_info['scrlistsInfo'] = $this->scrlists->get_all();
		$sub_info['tagsInfo'] = $this->tags->get_all();
		$sub_info['methodInfo'] = $this->distribute->get_all();
		$this->load->view('subscriber/subscriber_profile',$sub_info);
	 }

	public function add_subscriber()

	 {
	  $myprev = $this->privilege->get_by_userid($this->session->userdata('id'));
	 $valid = $myprev->subscriber_crud;
	 if($valid == '0')  {
		 
            $this->session->set_flashdata('flash_data', 'You don\'t have access!');
            redirect('dashboard/no_access');
			//exit();
			 
        }
		else {
			$this->load->model('SubscriptionType_model','type');
			$this->load->model('SubscriptionGroup_model','group');
			$this->load->model('InterestGroup_model','interest');
			$this->load->model('SubscriberLists_model','scrlists');
			$this->load->model('SubscriberTags_model','tags');

			$data['scrlistsInfo'] = $this->scrlists->get_all();
			$data['tagsInfo'] = $this->tags->get_all();
			$data['typeInfo'] = $this->type->get_all();
			$data['groupInfo'] = $this->group->get_all();
			$data['methodInfo'] = $this->distribute->get_all();
			$data['interestInfo'] = $this->interest->get_all();
			



			$data['pubsInfo'] = $this->pubs->get_all();
			$this->load->view('subscriber/add_subscriber',$data);

	  }

	 }

// for all subscriber list of any publication....
public function subscriber_list($pub)
	 {
	  $mydata['searchInfo'] = $this->person->custom_search_result($pub);
	// $mydata['subscriberList'] = $this->subs->subscriber_list($profile_id);
         
        
	 $this->load->view('subscriber/total_subscriber_list',$mydata);
	
	 }
public function subscriber_list_expired($pub)
	 {
	  $mydata['searchInfo1'] = $this->person->custom_search_result_dis_expired($pub);
	// $mydata['subscriberList'] = $this->subs->subscriber_list($profile_id);
         
        
	 $this->load->view('subscriber/total_subscriber_list_expired',$mydata);
	
	 }


public function update_note($id = NULL)

	 {

	  $data = array('note' => $this->input->post('note_details'));



	 $this->person->update(array('id' => $id), $data);

	 

	 }



	public function ajax_update()

	{

$myprev = $this->privilege->get_by_userid($this->session->userdata('id'));
		$valid = $myprev->subscriber_crud;
		$this->_validate();
		$valid1 = $myprev->user_id;

		$data = array(

				'name' => $this->input->post('name'),
				'occupation' => $this->input->post('occupation'),
				'designation' => $this->input->post('designation'),
				'company' => $this->input->post('company'),
				'email' => $this->input->post('email'),
				'phone' => $this->input->post('phone'),
				'alternative_phone' => $this->input->post('alternative_phone'),
				'date_of_birth' => $this->input->post('date_of_birth'),
				
                                 'house' => $this->input->post('house'),
                                 'area' => $this->input->post('area'),
				'state' => $this->input->post('state'),
                                 'city' => $this->input->post('city'),
				'zip' => $this->input->post('zip'),
				'country' => $this->input->post('country'),

				'category' => $this->input->post('category'),
				'type' => $this->input->post('type'),
				'tags' => $this->input->post('tags'),
				'tags_2' => $this->input->post('tags_2'),
				'tags_3' => $this->input->post('tags_3'),
				'scrlists' => $this->input->post('scrlists'),
				// 'user_id' =>$valid1,
                                //'fee' => $this->input->post('fee'),
				'start_date' => $this->input->post('start_date'),
                                 'group' => $this->input->post('group'),
                                 'interest' => $this->input->post('interest'),
                                 'publication_id' => $this->input->post('publication_id'),
				'status' => $this->input->post('status'),
				'distribution_method' => $this->input->post('distribution_method'),
			);

		$this->person->update(array('id' => $this->input->post('id')), $data);
		
	//// for billing address///////////////////////////

$billing_address = array(                'billing_house' => $this->input->post('billing_house'),
                                 'billing_area' => $this->input->post('billing_area'),
				'billing_state' => $this->input->post('billing_state'),
                                 'billing_city' => $this->input->post('billing_city'),
				'billing_zip' => $this->input->post('billing_zip'),
 				'billing_country' => $this->input->post('billing_country'),
	
			);
$meta_value = json_encode($billing_address);

$existing_meta = $this->submeta->get_by_billingAddress($this->input->post('id'));
if($existing_meta) { // if any new meta key exists... then do update

$subscriber_info = array('meta_value'=>$meta_value);

$update_billing = $this->submeta->update(array('subscriber_id'=>$this->input->post('id'), 'meta_key'=>'billing_address'), $subscriber_info); // execute the save function from user model
 } // end of if exisiting meta key found
///////////////////////////////////////////////	
if(!$existing_meta) {
$subscriber_info = array('subscriber_id'=>$this->input->post('id'), 'meta_key'=>'billing_address','meta_value'=>$meta_value);

$insert_billing = $this->submeta->save($subscriber_info); // execute the save function from user model		
		
}// end of if no meta key exists...




//// for subscription history ///////////////////

$existing_sub = $this->submeta->get_by_newSubscription($this->input->post('id'));

if($existing_sub) {

$data = array(      
                                 'category' => $this->input->post('category'),
                                 'type' => $this->input->post('type'),
                                 //'fee' => $this->input->post('fee'),
				
                                 
			);

$meta_value = json_encode($data);
$subscriber_info = array('start_date'=>date('Y-m-d'),'meta_value'=>$meta_value);

$update_meta = $this->submeta->update(array('subscriber_id'=>$this->input->post('id'), 'meta_key'=>'subscription'), $subscriber_info); // execute the save function from user model



}

if(!$existing_sub) {

$subscription_info = array(
	'category' => $this->input->post('category'),
                                 'type' => $this->input->post('type'),
                                 //'fee' => $this->input->post('fee'),
				
                                 
			);
$subscription_value = json_encode($subscription_info);

$subscriber_metainfo = array('subscriber_id'=>$this->input->post('id'), 'meta_key'=>'subscription', 'start_date' => date('Y-m-d'),'meta_value'=>$subscription_value);

$insert_subscription_meta = $this->submeta->save($subscriber_metainfo); // execute the save function from user model

}






		echo json_encode(array("status" => TRUE));

	}

public function distribution_log($pub,$sub)
	 {
	
         $mydata['pubID'] = $pub;
         $mydata['subID'] = $sub;
	 $this->load->view('subscriber/distribution_log',$mydata);
	//echo json_encode(array("status" => TRUE));
	 }

	public function ajax_delete($id)

	{

	  

		$this->person->delete_by_id($id);

		echo json_encode(array("status" => TRUE));

	}

/////// import subscribers from excel file.. /////////////

public function exim()
  {
$data['pubsInfo'] = $this->pubs->get_all();
$this->load->view('subscriber/export_import',$data);
  }

public function export_to_csv()

 {

  $this->load->library('excel');

 $this->excel->setActiveSheetIndex(0);

                //name the worksheet

                $this->excel->getActiveSheet()->setTitle('Products');

                //remove id and product_type column...
                $this->excel->getActiveSheet()->getColumnDimension('A')->setVisible(false);
$this->excel->getActiveSheet()->getColumnDimension('D')->setVisible(false);
//////// make description column wider...
$this->excel->getActiveSheet()->getColumnDimension('E')->setWidth(300);

 $this->excel->getActiveSheet()->getStyle('E')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);
 //make all headline bold color
                $this->excel->getActiveSheet()->getStyle('B3')->getFont()->setBold(true);
                $this->excel->getActiveSheet()->getStyle('C3')->getFont()->setBold(true);
                $this->excel->getActiveSheet()->getStyle('E3')->getFont()->setBold(true);
                $this->excel->getActiveSheet()->getStyle('F3')->getFont()->setBold(true);
                $this->excel->getActiveSheet()->getStyle('G3')->getFont()->setBold(true);
                $this->excel->getActiveSheet()->getStyle('H3')->getFont()->setBold(true);

                $this->excel->getActiveSheet()->setCellValue('A1', 'Product Excel Sheet');

                $this->excel->getActiveSheet()->setCellValue('B3', 'P.No.');

                $this->excel->getActiveSheet()->setCellValue('C3', 'Product Title');

                $this->excel->getActiveSheet()->setCellValue('E3', 'Description');
                $this->excel->getActiveSheet()->setCellValue('F3', 'Unit Price');
                  $this->excel->getActiveSheet()->setCellValue('G3', 'Default Qty');
                   $this->excel->getActiveSheet()->setCellValue('H3', 'Tax Rate');
				//$this->excel->getActiveSheet()->getColumnDimension('A2')->setVisible(false);

                //merge cell A1 until C1

                $this->excel->getActiveSheet()->mergeCells('A1:C1');

                //set aligment to center for that merged cell (A1 to C1)

                $this->excel->getActiveSheet()->getStyle('A1')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
               

                //make the font become bold

                $this->excel->getActiveSheet()->getStyle('A1')->getFont()->setBold(true);

                $this->excel->getActiveSheet()->getStyle('A1')->getFont()->setSize(16);

                $this->excel->getActiveSheet()->getStyle('A1')->getFill()->getStartColor()->setARGB('#333');
                
               

       for($col = ord('A'); $col <= ord('C'); $col++){

                //set column dimension

                $this->excel->getActiveSheet()->getColumnDimension(chr($col))->setAutoSize(true);

                 //change the font size

                $this->excel->getActiveSheet()->getStyle(chr($col))->getFont()->setSize(12);

                 

                $this->excel->getActiveSheet()->getStyle(chr($col))->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        }

                //retrive product table data

                $rs = $this->product->get_all();

                $exceldata="";

        foreach ($rs as $row){

                $exceldata[] = $row;

        }

                //Fill data 

				//$this->excel->getActiveSheet()->getStyle('A4')->setVisible(false);

				//$this->excel->getActiveSheet()->getStyle('A4')->getVisibility->setVisible(false);

              //  $this->excel->getActiveSheet()->fromArray($exceldata,true,);

                 

                $this->excel->getActiveSheet()->getStyle('A4')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

                $this->excel->getActiveSheet()->getStyle('B4')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

                $this->excel->getActiveSheet()->getStyle('C4')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

                 

                $filename='BillingBullProducts.csv'; //save our workbook as this file name

                header('Content-Type: application/vnd.ms-excel'); //mime type

                header('Content-Disposition: attachment;filename="'.$filename.'"'); //tell browser what's the file name

                header('Cache-Control: max-age=0'); //no cache

 

                //save it to Excel5 format (excel 2003 .XLS file), change this to 'Excel2007' (and adjust the filename extension, also the header mime type)

                //if you want to save it as .XLSX Excel 2007 format

                $objWriter = PHPExcel_IOFactory::createWriter($this->excel, 'Excel5');  

                //force user to download the Excel file without writing it to server's HD

                $objWriter->save('php://output');

 

 }

 /*
public function export_to_excel($pub)

 {
  $data['subInfo'] = $this->person->get_all($pub);
 $this->load->view('subscriber/spreadsheet_view',$data);

 

 }
 */
    public function export_to_excel($pub)

    {

        $this->load->library('excel');

        $this->excel->setActiveSheetIndex(0);

        //name the worksheet

        $this->excel->getActiveSheet()->setTitle('Subscriber');

        //remove id column
        $this->excel->getActiveSheet()->getColumnDimension('A')->setVisible(false);

        //make all headline bold color
        $this->excel->getActiveSheet()->getStyle('B1:W1')->getFont()->setBold(true);
        $this->excel->getActiveSheet()->getStyle('B1:W1')->getFont()->setSize(16);
        $this->excel->getActiveSheet()->setCellValue('A1', 'ID');
        $this->excel->getActiveSheet()->setCellValue('B1', 'Name');
        $this->excel->getActiveSheet()->setCellValue('C1', 'Occupation');
        $this->excel->getActiveSheet()->setCellValue('D1', 'Designation');
        $this->excel->getActiveSheet()->setCellValue('E1', 'Company');
        $this->excel->getActiveSheet()->setCellValue('F1', 'Email');
        $this->excel->getActiveSheet()->setCellValue('G1', 'Phone');
        $this->excel->getActiveSheet()->setCellValue('H1', 'Alternative Phone');

        $this->excel->getActiveSheet()->setCellValue('I1', 'Date of Birth');
        $this->excel->getActiveSheet()->setCellValue('J1', 'House/Street');
        $this->excel->getActiveSheet()->setCellValue('K1', 'Area');
        $this->excel->getActiveSheet()->setCellValue('L1', 'State');
        $this->excel->getActiveSheet()->setCellValue('M1', 'City');
        $this->excel->getActiveSheet()->setCellValue('N1', 'Zip');
        $this->excel->getActiveSheet()->setCellValue('O1', 'Country');

        $this->excel->getActiveSheet()->setCellValue('P1', 'Category');
        $this->excel->getActiveSheet()->setCellValue('Q1', 'Subscription Type');
        $this->excel->getActiveSheet()->setCellValue('R1', 'Subscription Date');
        $this->excel->getActiveSheet()->setCellValue('S1', 'Group');
        $this->excel->getActiveSheet()->setCellValue('T1', 'Interest');

        $this->excel->getActiveSheet()->setCellValue('U1', 'Publication');
        $this->excel->getActiveSheet()->setCellValue('V1', 'Status');
        $this->excel->getActiveSheet()->setCellValue('W1', 'Distribution Method');



        //$this->excel->getActiveSheet()->getColumnDimension('A2')->setVisible(false);





        for($col = ord('A'); $col <= ord('W'); $col++){

            //set column dimension

            $this->excel->getActiveSheet()->getColumnDimension(chr($col))->setAutoSize(true);

        }

        //retrive product table data

        $rs = $this->person->get_all($pub);

        $exceldata="";

        foreach ($rs as $row) {

                $exceldata[] = $row;

        }

        $this->excel->getActiveSheet()->fromArray($exceldata, NULL, 'A2',true);



        $filename='Subscribers.xls'; //save our workbook as this file name

        header('Content-Type: application/vnd.ms-excel'); //mime type

        header('Content-Disposition: attachment;filename="'.$filename.'"'); //tell browser what's the file name

        header('Cache-Control: max-age=0'); //no cache



        //save it to Excel5 format (excel 2003 .XLS file), change this to 'Excel2007' (and adjust the filename extension, also the header mime type)

        //if you want to save it as .XLSX Excel 2007 format

        $objWriter = PHPExcel_IOFactory::createWriter($this->excel, 'Excel5');

        //force user to download the Excel file without writing it to server's HD

        $objWriter->save('php://output');



    }

public function export_to_pdf()
	  { /*
//$data = [];
$data['subscriberInfo'] = $this->person->get_all();	
        //load the view and saved it into $html variable
       // $html=$this->load->view('welcome_message', $data, true);
 
	 $html = $this->load->view('product-service/pdf_product', $data,true);
        //this the the PDF filename that user will get to download
        $pdfFilePath = "BillingBullProducts".".pdf";
 
        //load mPDF library
        $this->load->library('m_pdf');
 
       //generate the PDF from the given html
        $this->m_pdf->pdf->WriteHTML($html);
 
        //download it.
        $this->m_pdf->pdf->Output($pdfFilePath, "D"); 	   
	 */
	  } 



  public function import_me()
  {
  if(isset($_FILES["userFile"]) && $_FILES["userFile"]["error"]== UPLOAD_ERR_OK)
{
	############ Edit settings ##############
	$UploadDirectory	= 'uploads/'; //specify upload directory ends with / (slash)
	##########################################
	
	/*
	Note : You will run into errors or blank page if "memory_limit" or "upload_max_filesize" is set to low in "php.ini". 
	Open "php.ini" file, and search for "memory_limit" or "upload_max_filesize" limit 
	and set them adequately, also check "post_max_size".
	*/
	
	//check if this is an ajax request
	if (!isset($_SERVER['HTTP_X_REQUESTED_WITH'])){
		die();
	}
	
	
	//Is file size is less than allowed size.
	if ($_FILES["userFile"]["size"] > 50000) { // max 5 MB
		die("<font color='#ff0000'>File size is too big!</font>");
	}
	
	//allowed file type Server side check
	switch(strtolower($_FILES['userFile']['type']))
		{
			//allowed file types
            
			case 'application/vnd.ms-excel':
			
				break;
			default:
				die('<font color="#ff0000">Unsupported File! </font>'); //output error
	}
	
	$File_Name          = strtolower($_FILES['userFile']['name']);
	//$File_Ext           = substr($File_Name, strrpos($File_Name, '.')); //get file extention
	//$Random_Number      = rand(0, 9999999999); //Random number to be added to name.
	//$NewFileName 		= $Random_Number.$File_Ext; //new file name
	
	if(move_uploaded_file($_FILES['userFile']['tmp_name'], $UploadDirectory.$File_Name ))
	   {
	   
// strat importing....////////////////////////.
$this->load->library('Excel');
 try {
/// it will be your file name that you are posting with a form or can pass static name $_FILES["file"]["name"];
   $inputFileType = PHPExcel_IOFactory::identify($UploadDirectory.$File_Name);
    $objReader = PHPExcel_IOFactory::createReader($inputFileType);
	$objPHPExcel = $objReader->load($UploadDirectory.$File_Name);
    $i=0;
	$allDataInSheet = $objPHPExcel->getActiveSheet()->toArray(false,true,true,true);
    // $allDataInSheet = array_splice($allDataInSheet,0,1);
 foreach($allDataInSheet as $import)
		{
  if($i!=0) {
      $data = array(
          'name' => $import['A'],
          'occupation' => $import['B'],
          'designation' => $import['C'],
          'company' => $import['D'],
          'email' => $import['E'],
          'phone' => $import['F'],
          'alternative_phone' => $import['G'],
          'date_of_birth' => $import['H'],
          'house' => $import['I'],
          'area' => $import['J'],
          'state' => $import['K'],
          'city' => $import['L'],
          'zip' => $import['M'],
          'country' => $import['N'],
          'category' => $import['O'],
          'type' => $import['P'],
          //'fee' => $import['Q'],
          'start_date' => $import['Q'],
          'group' => $import['R'],
          'interest' => $import['S'],
          'publication_id' => $import['T'],
          'status' => $import['U'],
          'distribution_method' => $import['V'],


      );


      $insert = $this->person->save($data);
      echo $import['B'].'<br>';
  }

//if(!$insert) {echo 'can not import file....'; /* exit(); */}
		//$this->product->import_data($data);
$i++;
}

// remove uploaded file after successfully imported 
 $absolutedir			= dirname(__FILE__);
//$absolutedir = str_replace('\controllers','',$absolutedir);
$upload_dir = str_replace('application/controllers','',$absolutedir);
$dir					= '/uploads/';
$serverdir				= $upload_dir.$dir;
  
// unlink($serverdir.$File_Name ); // remove the uploaded file (updated on 26.11.2016
      
     }
 catch(Exception $e)
    {
	die('Something wrong with upload! Is "upload_max_filesize" set correctly?');
			 /*$this->resp->success = FALSE;
			 $this->resp->msg = 'Error Uploading file';
			 echo json_encode($this->resp);
			 exit;*/
    }
 

	}// end of uploading task
	
	else{
		die('<font color="#ff0000">error uploading File!</font>');
	}
	
}
else
{
	die('Something wrong with upload! Is "upload_max_filesize" set correctly?');
}
  
  
  }
  
  //////////////// Reporting part //////////////////////
  
  public function reporting()

	{
	$myprev = $this->privilege->get_by_userid($this->session->userdata('id'));
	 $valid = $myprev->subscriber_report;
	 if($valid == '0')  {
		 
            $this->session->set_flashdata('flash_data', 'You don\'t have access!');
            redirect('dashboard/no_access');
			//exit();
			 
        }
		else {
	//$this->load->model('UserPrevileges_model','allow');
	//$allowed = $this->allow->get_by_userid($this->session->userdata('id'));
    $mydata['pubsInfo'] = $this->pubs->get_all();
	$mydata['typeInfo'] = $this->type->get_all();
	//if(($allowed->reporting)=='1') {
	$this->load->view('subscriber/all_reports',$mydata);
         //}
        // else { $this->load->view('dashboard'); }
		}
	}
	
	public function list_by_month()

	{ 
	 $pub = $this->input->post('publication_id');
	 $year = $this->input->post('year');
	 $month = $this->input->post('month');
	 $start = date("Y-".$month."-01", strtotime($year.'-'.$month.'-01'));// get start date from here
     $end = date("Y-".$month."-t", strtotime($start));
     $paid = 'Paid';
     $comp = 'Complementary';
	$list['subsInfo'] = $this->person->subscriber_by_daterange($pub,$start,$end,$type=NULL);
	$list['totalSubscriber'] = $this->person->total_subscribers($pub,$start,$end,$type=NULL);
	$list['totalPaid'] = $this->person->total_subscriber_by_category($pub,$start,$end,$paid,$type=NULL);
	$list['totalComplementary'] = $this->person->total_subscriber_by_category($pub,$start,$end,$comp,$type=NULL);
	$list['totalIncome'] = $this->person->total_income($pub,$start,$end,$type=NULL);
	$list['totalAdIncome'] = $this->person->total_adIncome($pub,$start,$end,$type=NULL);
    $list['year'] = $year;
	$list['month'] = $month;
	$list['pubsInfo'] = $this->pubs->get_by_id($pub);
	$this->load->view('subscriber/reporting/monthly_report',$list);
	}

public function list_by_daterange()

	{ 
	 $pub = $this->input->post('publication_id');
	 $start = $this->input->post('start_date');
	 $end = $this->input->post('end_date');
	 $paid = 'Paid';
     $comp = 'Complementary';
	$list['subsInfo'] = $this->person->subscriber_by_daterange($pub,$start,$end, $type=NULL);
	$list['totalSubscriber'] = $this->person->total_subscribers($pub,$start,$end,$type=NULL);
	$list['totalPaid'] = $this->person->total_subscriber_by_category($pub,$start,$end,$paid,$type=NULL);
	$list['totalComplementary'] = $this->person->total_subscriber_by_category($pub,$start,$end,$comp,$type=NULL);
	$list['totalIncome'] = $this->person->total_income($pub,$start,$end,$type=NULL);
	$list['totalAdIncome'] = $this->person->total_adIncome($pub,$start,$end,$type=NULL);
    $list['start'] = $start;
	$list['end'] = $end;
	$list['pubsInfo'] = $this->pubs->get_by_id($pub);
	$this->load->view('subscriber/reporting/daterange_report',$list);
	}

public function list_by_month_and_type()

	{ 
	 $pub = $this->input->post('publication_id');
	 $year = $this->input->post('year');
	 $month = $this->input->post('month'); 
	 $type = $this->input->post('type');
	 $start = date("Y-".$month."-01", strtotime($year.'-'.$month.'-01'));// get start date from here
     $end = date("Y-".$month."-t", strtotime($start));
     $paid = 'Paid';
     $comp = 'Complementary';
	$list['subsInfo'] = $this->person->subscriber_by_type($pub,$start,$end,$type);
	$list['totalSubscriber'] = $this->person->total_subscribers($pub,$start,$end,$type);
	$list['totalPaid'] = $this->person->total_subscriber_by_category($pub,$start,$end,$paid,$type);
	$list['totalComplementary'] = $this->person->total_subscriber_by_category($pub,$start,$end,$comp,$type);
	$list['totalIncome'] = $this->person->total_income($pub,$start,$end,$type);
	$list['totalAdIncome'] = $this->person->total_adIncome($pub,$start,$end,$type);
    $list['year'] = $year;
	$list['month'] = $month;
	$list['pubsInfo'] = $this->pubs->get_by_id($pub);
	$list['typeInfo'] = $this->type->get_by_id($type);
	$this->load->view('subscriber/reporting/typewise_monthly_report',$list);
	}



public function list_by_daterange_type()

	{ 
	 $pub = $this->input->post('publication_id');
	 $start = $this->input->post('start_date');
	 $end = $this->input->post('end_date');
	 $type = $this->input->post('type');
	  $paid = 'Paid';
     $comp = 'Complementary';
	$list['subsInfo'] = $this->person->subscriber_by_type($pub,$start,$end,$type);
	$list['totalSubscriber'] = $this->person->total_subscribers($pub,$start,$end,$type);
	$list['totalPaid'] = $this->person->total_subscriber_by_category($pub,$start,$end,$paid,$type);
	$list['totalComplementary'] = $this->person->total_subscriber_by_category($pub,$start,$end,$comp,$type);
	$list['totalIncome'] = $this->person->total_income($pub,$start,$end,$type);
	$list['totalAdIncome'] = $this->person->total_adIncome($pub,$start,$end,$type);
    $list['start'] = $start;
	$list['end'] = $end;
	$list['pubsInfo'] = $this->pubs->get_by_id($pub);
	$list['typeInfo'] = $this->type->get_by_id($type);
	$this->load->view('subscriber/reporting/typewise_daterange_report',$list);
	}

public function list_by_year()

	{ 
	 $pub = $this->input->post('publication_id');
	 $year = $this->input->post('year');
	 $start = date("Y-01-01", strtotime($year.'-01-01'));// get start date from here
     $end = date("Y-12-t", strtotime($start));
     $paid = 'Paid';
     $comp = 'Complementary';
	$list['subsInfo'] = $this->person->subscriber_by_daterange($pub,$start,$end, $type=NULL);
	$list['totalSubscriber'] = $this->person->total_subscribers($pub,$start,$end,$type=NULL);
	$list['totalPaid'] = $this->person->total_subscriber_by_category($pub,$start,$end,$paid,$type=NULL);
	$list['totalComplementary'] = $this->person->total_subscriber_by_category($pub,$start,$end,$comp,$type=NULL);
	$list['totalIncome'] = $this->person->total_income($pub,$start,$end,$type=NULL);
	$list['totalAdIncome'] = $this->person->total_adIncome($pub,$start,$end,$type=NULL);
    $list['year'] = $year;
	$list['pubsInfo'] = $this->pubs->get_by_id($pub);
	$this->load->view('subscriber/reporting/yearly_report',$list);
	}

public function list_by_year_type()

	{ 
	 $pub = $this->input->post('publication_id');
	 $year = $this->input->post('year');
	 $start = date("Y-01-01", strtotime($year.'-01-01'));// get start date from here
     $end = date("Y-12-t", strtotime($start));
	 $type = $this->input->post('type');
	 $paid = 'Paid';
     $comp = 'Complementary';
	$list['subsInfo'] = $this->person->subscriber_by_type($pub,$start,$end,$type);
	$list['totalSubscriber'] = $this->person->total_subscribers($pub,$start,$end,$type);
	$list['totalPaid'] = $this->person->total_subscriber_by_category($pub,$start,$end,$paid,$type);
	$list['totalComplementary'] = $this->person->total_subscriber_by_category($pub,$start,$end,$comp,$type);
	$list['totalIncome'] = $this->person->total_income($pub,$start,$end,$type);
	$list['totalAdIncome'] = $this->person->total_adIncome($pub,$start,$end,$type);
    $list['year'] = $year;
	$list['pubsInfo'] = $this->pubs->get_by_id($pub);
	$list['typeInfo'] = $this->type->get_by_id($type);
	$this->load->view('subscriber/reporting/typewise_yearly_report',$list);
	}
public function list_by_areawise()

	{ 
	 $pub = $this->input->post('publication_id');
	 $area = $this->input->post('area');
	 $paid = 'Paid';
     $comp = 'Complementary';
	$list['subsInfo'] = $this->person->subscriber_by_type($pub,$start,$end,$type);
	$list['totalSubscriber'] = $this->person->total_subscribers($pub,$start,$end,$type);
	$list['totalPaid'] = $this->person->total_subscriber_by_category($pub,$start,$end,$paid,$type);
	$list['totalComplementary'] = $this->person->total_subscriber_by_category($pub,$start,$end,$comp,$type);
	$list['totalIncome'] = $this->person->total_income($pub,$start,$end,$type);
	$list['totalAdIncome'] = $this->person->total_adIncome($pub,$start,$end,$type);
    $list['year'] = $year;
	$list['pubsInfo'] = $this->pubs->get_by_id($pub);
	$list['typeInfo'] = $this->type->get_by_id($type);
	$list['areaInfo'] = $this->person->get_by_id($area);
	var_dump($list['areaInfo']);
	$this->load->view('subscriber/reporting/areawise_report',$list);
	}
  
  
  
  
  
  
  
  
  
  

//////////////////////////// validation functions /////////////////////
	private function _validate()

	{

		$data = array();

		$data['error_string'] = array();

		$data['inputerror'] = array();

		$data['status'] = TRUE;

    
if($this->input->post('publication_id') == '0')

		{

			//$data['inputerror'][] = 'name';

			$data['error_string'][] = 'publicaiton required';

			$data['status'] = FALSE;

		}


		if($this->input->post('name') == '')

		{

			$data['inputerror'][] = 'name';

			$data['error_string'][] = 'Name required';

			$data['status'] = FALSE;

		}



		



		if($this->input->post('email') == '' || !filter_var($this->input->post('email'), FILTER_VALIDATE_EMAIL) )
		

		{

			$data['inputerror'][] = 'email';

			$data['error_string'][] = 'invalid Email address';

			$data['status'] = FALSE;

		}



		if($this->input->post('phone') == '' )

		{

			$data['inputerror'][] = 'phone';

			$data['error_string'][] = 'phone no. required';

			$data['status'] = FALSE;

		}
		
		if($this->input->post('category') == '0')

		{

			//$data['inputerror'][] = 'category';

			//$data['error_string'][] = 'status required';

			$data['status'] = FALSE;

		}
		
		if($this->input->post('type') == '0')

		{

			$data['inputerror'][] = 'type';

			$data['error_string'][] = 'type required';

			$data['status'] = FALSE;

		}
		
	if($this->input->post('start_date') == '')

		{

			$data['inputerror'][] = 'start_date';

			$data['error_string'][] = 'start date required';

			$data['status'] = FALSE;

		}




		if($data['status'] === FALSE)

		{

			echo json_encode($data);

			exit();

		}

	}

	
	private function _validate_renew()

	{

		$data = array();

		$data['error_string'] = array();

		$data['inputerror'] = array();

		$data['status'] = TRUE;

    
		
		if($this->input->post('category') == '0')

		{

			//$data['inputerror'][] = 'category';

			$data['error_string'][] = 'category required';

			$data['status'] = FALSE;

		}
		
		if($this->input->post('type') == '0')

		{

			//$data['inputerror'][] = 'type';

			$data['error_string'][] = 'type required';

			$data['status'] = FALSE;

		}
		
	if($this->input->post('start_date') == '')

		{

			$data['inputerror'][] = 'start_date';

			$data['error_string'][] = 'start date required';

			$data['status'] = FALSE;

		}




		if($data['status'] === FALSE)

		{

			echo json_encode($data);

			exit();

		}

	}


	



}
