<?php

defined('BASEPATH') OR exit('No direct script access allowed');
  


class Distribution extends CI_Controller {
	public function __construct()
	{
		parent::__construct();
 		if(empty($this->session->userdata('id')) ) {
            $this->session->set_flashdata('flash_data', 'You don\'t have access!');
            redirect('login'); 
        }
		$this->load->model('distribution_model','distribute');
		//$this->load->model('payment_model','payment');
		$this->load->model('distributionMeta_model','subs');
		//$this->load->model('contractActivity_model','activity');
        //$this->load->model('position_model','position');
		$this->load->model('publication_model','pubs');
		//$this->load->model('advertiser_model','adv');
		$this->load->model('subscriber_model','person');
		$this->load->model('UserPrivileges_model','privilege');
		$this->load->helper('url'); // to load header footer or anyother url related links....

		$this->load->library('upload'); // to upload image

		$this->load->helper('directory'); //load directory helper ot show client image from upload folder 

		$this->load->library('form_validation');

		

	}



	public function index()

	{

	
$mydata['pubsInfo'] = $this->pubs->get_all();

$this->load->view('distribution/all_distribution',$mydata);

	}

	

	public function ajax_list()

	{

	$list = $this->contra->get_datatables();
	$data = array();

		$no = $_POST['start'];
        $sn = 1;
		foreach ($list as $pos) {

			$no++;

			$row = array();
            $p_pubs = $this->pubs->get_by_id($pos->publication_id);
			$p_adv = $this->adv->get_by_id($pos->advertiser_id);
			 $p_position = $this->position->get_by_id($pos->position_id);
			 $row[] = $pos->reference_no;
			$row[] = $p_pubs->name;
			$row[] = $p_adv->name;
			$row[] = $p_position->title;
			//additional fields.....

			$row[] = '<a class="btn btn-icon-only yellow" href="'.base_url().'contract/details/'.$pos->id.'"><i class="fa fa-eye"></i></a><a class="btn btn-icon-only red" href="javascript:void()" title="Edit" onclick="delete_contract('."'".$pos->id."'".')"><i class="fa fa-trash"></i></a> ';

			$data[] = $row;
          $sn++;
		}



		$output = array(

						"draw" => $_POST['draw'],

						"recordsTotal" => $this->pubs->count_all(),

						"recordsFiltered" => $this->pubs->count_filtered(),

						"data" => $data,

						

				);

		//output to json format

		echo json_encode($output);

	}

public function add_subscriber_from_category($pub,$cat,$profileID=null)

	{
	$list = $this->person->get_by_category($pub,$cat);
	
	 $existing_subscriber = $this->subs->subscriber_list($profileID,"subscriber");
	
	// if($existing_subscriber) { // if any delivery already occured 
	
	
	if($list) { // if any data passed from click event
	  //$mystring = '';
	  $m = array();
	 foreach($list as $lst) { array_push($m,$lst->id);}
	 
	  
	 if($existing_subscriber->meta_value != '') {
	$mystring = $existing_subscriber->meta_value;  // 1. get the meta_value with a comma as suffix..
	                     
	$mystring = explode(',',$mystring);
	 foreach($mystring as $str) {
	 
	  array_push($m,$str);
	  
	   }            
	
	 } // end of if any data found previoulsy
	 
	 
	 $duplicate_value = array();
	
	 
	 // a. put duplicate values into $duplicates array
	$duplicates = array_diff_assoc($m, array_unique($m));
	 
	 
	$result = array_unique($m);              //5. avoid any duplicate item in the array
	
	$newString = implode(',',$result);           // 6. convert the result array to string again 
    // print_r($newString);
    $newMeta = array('meta_value'=>$newString);    // 7. now update the meta_value with new string
	 		
//$this->contract_meta->update(array('contract_id' => $this->input->post('id'),'meta_key'=>'issue'),$newMeta);	
    
    
    $this->subs->update(array('id' => $existing_subscriber->id),  $newMeta);
    
   if($duplicates) {
    echo '<h4>Duplicate Subscribers</h4><table class="table table-bordered">';
      $sn = 1;
      foreach($duplicates as $dup) {
     $myname =  $this->person->get_by_id($dup);
      echo '<tr><td align="center">'.$sn++.'</td>'.'<td>'.$myname->name.'</td></tr>';
       
        }
     echo '<tr><td colspan="2" align="right"><a href="'.base_url().'distribution/view/'.$profileID.'" class="btn btn-primary"> OK </a></td></tr></table>';
    }
    if(!$duplicates) {  echo 'no-duplicacy'; } 
	//echo json_encode(array("status" => TRUE));
	
	 } //  end of new data passed from click event checking
	 
	// } //end of update.... if any delivery already occured
	 
if(!$list) {  echo 'no-data'; } 
	
	}
public function add_subscriber_from_type($pub,$type,$profileID=null)

	{
	$list = $this->person->get_by_type($pub,$type);
	
	 $existing_subscriber = $this->subs->subscriber_list($profileID,"subscriber");
	
	 if($list) { // if any data passed from click event
	
	
	
	  //$mystring = '';
	  $m = array();
	 foreach($list as $lst) { array_push($m,$lst->id);}
	 
	  
	 if($existing_subscriber->meta_value != '') {
	$mystring = $existing_subscriber->meta_value;  // 1. get the meta_value with a comma as suffix..
	                     
	$mystring = explode(',',$mystring);
	 foreach($mystring as $str) {
	 
	  array_push($m,$str);
	  
	   }            
	
	 } // end of if any data found previoulsy
	 
	 
	 $duplicate_value = array();
	
	 
	 // a. put duplicate values into $duplicates array
	$duplicates = array_diff_assoc($m, array_unique($m));
	 
	 
	$result = array_unique($m);              //5. avoid any duplicate item in the array
	
	$newString = implode(',',$result);           // 6. convert the result array to string again 
    // print_r($newString);
    $newMeta = array('meta_value'=>$newString);    // 7. now update the meta_value with new string
	 		
//$this->contract_meta->update(array('contract_id' => $this->input->post('id'),'meta_key'=>'issue'),$newMeta);	
    
    
    $this->subs->update(array('id' => $existing_subscriber->id),  $newMeta);
    
    if($duplicates) {
     echo '<h4>Duplicate Subscribers</h4><table class="table table-bordered">';
      $sn = 1;
      foreach($duplicates as $dup) {
     $myname =  $this->person->get_by_id($dup);
      echo '<tr><td align="center">'.$sn++.'</td>'.'<td>'.$myname->name.'</td></tr>';
       
        }
     echo '<tr><td colspan="2" align="right"><a href="'.base_url().'distribution/view/'.$profileID.'" class="btn btn-primary"> OK </a></td></tr></table>';
    }
    if(!$duplicates) {  echo 'no-duplicacy'; } 
	//echo json_encode(array("status" => TRUE));
	
	 } //  end of new data passed from click event checking
	 
if(!$list) {  echo 'no-data'; } 
	}

public function add_subscriber_from_group($pub,$grp,$profileID=null)

	{
	$list = $this->person->get_by_group($pub,$grp);
	
	 $existing_subscriber = $this->subs->subscriber_list($profileID,"subscriber");
	
	if($list) { // if any data passed from click event
	
	
	  $m = array();
	 foreach($list as $lst) { array_push($m,$lst->id);}
	 
	  
	 if($existing_subscriber->meta_value != '') {
	$mystring = $existing_subscriber->meta_value;  // 1. get the meta_value with a comma as suffix..
	                     
	$mystring = explode(',',$mystring);
	 foreach($mystring as $str) {
	 
	  array_push($m,$str);
	  
	   }            
	
	 } // end of if any data found previoulsy
	 
	 
	 $duplicate_value = array();
	
	 
	 // a. put duplicate values into $duplicates array
	$duplicates = array_diff_assoc($m, array_unique($m));
	 
	 
	$result = array_unique($m);              //5. avoid any duplicate item in the array
	
	$newString = implode(',',$result);           // 6. convert the result array to string again 
    // print_r($newString);
    $newMeta = array('meta_value'=>$newString);    // 7. now update the meta_value with new string
	 		
        
    $this->subs->update(array('id' => $existing_subscriber->id),  $newMeta);
    
    if($duplicates) {
     echo '<h4>Duplicate Subscribers</h4><table class="table table-bordered">';
      $sn = 1;
      foreach($duplicates as $dup) {
     $myname =  $this->person->get_by_id($dup);
      echo '<tr><td align="center">'.$sn++.'</td>'.'<td>'.$myname->name.'</td></tr>';
       
        }
     echo '<tr><td colspan="2" align="right"><a href="'.base_url().'distribution/view/'.$profileID.'" class="btn btn-primary"> OK </a></td></tr></table>';
    }
    if(!$duplicates) {  echo 'no-duplicacy'; } 
	
	
	 } //  end of new data passed from click event checking
	 

 
if(!$list) {  echo 'no-data'; } 
	
	}
	









// list add

public function add_subscriber_from_lists($pub,$lists,$profileID=null)

	{
	$list = $this->person->get_by_lists($pub,$lists);
	

	 $existing_subscriber = $this->subs->subscriber_list($profileID,"subscriber");
	
	if($list) { // if any data passed from click event
	
	
	  $m = array();
	 foreach($list as $lst) { array_push($m,$lst->id);}
	 
	  
	 if($existing_subscriber->meta_value != '') {
	$mystring = $existing_subscriber->meta_value;  // 1. get the meta_value with a comma as suffix..
	                     
	$mystring = explode(',',$mystring);
	 foreach($mystring as $str) {
	 
	  array_push($m,$str);
	  
	   }            
	
	 } // end of if any data found previoulsy
	 
	 
	 $duplicate_value = array();
	
	 
	 // a. put duplicate values into $duplicates array
	$duplicates = array_diff_assoc($m, array_unique($m));
	 
	 
	$result = array_unique($m);              //5. avoid any duplicate item in the array
	
	$newString = implode(',',$result);           // 6. convert the result array to string again 
    // print_r($newString);
    $newMeta = array('meta_value'=>$newString);    // 7. now update the meta_value with new string
	 		
        
    $this->subs->update(array('id' => $existing_subscriber->id),  $newMeta);
    
    if($duplicates) {
     echo '<h4>Duplicate Subscribers</h4><table class="table table-bordered">';
      $sn = 1;
      foreach($duplicates as $dup) {
     $myname =  $this->person->get_by_id($dup);
      echo '<tr><td align="center">'.$sn++.'</td>'.'<td>'.$myname->name.'</td></tr>';
       
        }
     echo '<tr><td colspan="2" align="right"><a href="'.base_url().'distribution/view/'.$profileID.'" class="btn btn-primary"> OK </a></td></tr></table>';
    }
    if(!$duplicates) {  echo 'no-duplicacy'; } 
	
	
	 } //  end of new data passed from click event checking
	 

 
if(!$list) {  echo 'no-data'; } 
	
	}

//list filter end

//expaired subscriber list


// public function add_subscriber_from_expired($pub,$expired,$profileID=null)

// 	{
// 	$post = $this->input->post();
// 	 $existing_subscriber = $this->subs->subscriber_list_expired($profileID,"subscriber");
	
	 
	
// 	if($post['active_subscriber']) { // if any data passed from click event
// 	  $mystring = '';
	
// 	 if($existing_subscriber->meta_value != '') {
// 	$mystring = $existing_subscriber->meta_value.',';  // 1. get the meta_value with a comma as suffix..
// 	                                     }
	
// 	 for($i=0; $i<count($post['active_subscriber']); $i++) { // 2. loop through the submited data.
// 	// array_push($myarray, $post['all_subscriber'][$i]);
// 	  $mystring.= $post['active_subscriber'][$i];             // 3. append new item to the list 
// 	  if($i<count($post['active_subscriber'])-1) {$mystring.=',';}
// 	 }
// 	 $myarr = array();
	 
// 	 $mystring = explode(',',$mystring);
	 
// 	 foreach($mystring as $str) {
	 
// 	  array_push($myarr,$str);
	  
// 	   } //4. push the string to an array
	 
// 	 // a. put duplicate values into $duplicates array
// 	$duplicates = array_diff_assoc($myarr, array_unique($myarr));
	 
	 
// 	$result = array_unique($myarr);              //5. avoid any duplicate item in the array
	
// 	$newString = implode(',',$result);           // 6. convert the result array to string again 
//     // print_r($newString);
//     $newMeta = array('meta_value'=>$newString);    // 7. now update the meta_value with new string
	 		
// //$this->contract_meta->update(array('contract_id' => $this->input->post('id'),'meta_key'=>'issue'),$newMeta);	
    
    
//     $this->subs->update(array('id' => $existing_subscriber->id),  $newMeta);
    
//   if($duplicates) {
//         //$dupli = 1;
//     echo '<h4>Duplicate Subscribers</h4><table class="table table-bordered">';
//       $sn = 1;
//       foreach($duplicates as $dup) {
//      $myname =  $this->person->get_by_id($dup);
//       echo '<tr><td align="center">'.$sn++.'</td>'.'<td>'.$myname->name.'</td></tr>';
       
//         }
//      echo '</table><div style="text-align:right;"><a href="'.base_url().'distribution/view/'.$profileID.'" class="btn btn-primary"> OK </a></div>';
//     }
    
//    if(!$duplicates) { echo 'no-duplicacy'; } 
    
// 	//echo $dupli; //json_encode(array("duplicacy" => $dupli));
	
// 	 } //  end of new data passed from click event checking
	 
// 	if(!$post['active_subscriber']) {  echo 'no-data'; } 

// 	}


//end expaired subscriber list 




public function add_subscriber($profileID)

	{
	$post = $this->input->post();
	 $existing_subscriber = $this->subs->subscriber_list($profileID,"subscriber");
	
	 
	
	if($post['active_subscriber']) { // if any data passed from click event
	  $mystring = '';
	
	 if($existing_subscriber->meta_value != '') {
	$mystring = $existing_subscriber->meta_value.',';  // 1. get the meta_value with a comma as suffix..
	                                     }
	
	 for($i=0; $i<count($post['active_subscriber']); $i++) { // 2. loop through the submited data.
	// array_push($myarray, $post['all_subscriber'][$i]);
	  $mystring.= $post['active_subscriber'][$i];             // 3. append new item to the list 
	  if($i<count($post['active_subscriber'])-1) {$mystring.=',';}
	 }
	 $myarr = array();
	 
	 $mystring = explode(',',$mystring);
	 
	 foreach($mystring as $str) {
	 
	  array_push($myarr,$str);
	  
	   } //4. push the string to an array
	 
	 // a. put duplicate values into $duplicates array
	$duplicates = array_diff_assoc($myarr, array_unique($myarr));
	 
	 
	$result = array_unique($myarr);              //5. avoid any duplicate item in the array
	
	$newString = implode(',',$result);           // 6. convert the result array to string again 
    // print_r($newString);
    $newMeta = array('meta_value'=>$newString);    // 7. now update the meta_value with new string
	 		
//$this->contract_meta->update(array('contract_id' => $this->input->post('id'),'meta_key'=>'issue'),$newMeta);	
    
    
    $this->subs->update(array('id' => $existing_subscriber->id),  $newMeta);
    
  if($duplicates) {
        //$dupli = 1;
    echo '<h4>Duplicate Subscribers</h4><table class="table table-bordered">';
      $sn = 1;
      foreach($duplicates as $dup) {
     $myname =  $this->person->get_by_id($dup);
      echo '<tr><td align="center">'.$sn++.'</td>'.'<td>'.$myname->name.'</td></tr>';
       
        }
     echo '</table><div style="text-align:right;"><a href="'.base_url().'distribution/view/'.$profileID.'" class="btn btn-primary"> OK </a></div>';
    }
    
   if(!$duplicates) { echo 'no-duplicacy'; } 
    
	//echo $dupli; //json_encode(array("duplicacy" => $dupli));
	
	 } //  end of new data passed from click event checking
	 
	if(!$post['active_subscriber']) {  echo 'no-data'; } 

	}


public function add_subscriber_expired($profileID)

	{
	$post = $this->input->post();
	 $existing_subscriber = $this->subs->subscriber_list_expired($profileID,"subscriber");
	
	 
	
	if($post['active_subscriber']) { // if any data passed from click event
	  $mystring = '';
	
	 if($existing_subscriber->meta_value != '') {
	$mystring = $existing_subscriber->meta_value.',';  // 1. get the meta_value with a comma as suffix..
	                                     }
	
	 for($i=0; $i<count($post['active_subscriber']); $i++) { // 2. loop through the submited data.
	// array_push($myarray, $post['all_subscriber'][$i]);
	  $mystring.= $post['active_subscriber'][$i];             // 3. append new item to the list 
	  if($i<count($post['active_subscriber'])-1) {$mystring.=',';}
	 }
	 $myarr = array();
	 
	 $mystring = explode(',',$mystring);
	 
	 foreach($mystring as $str) {
	 
	  array_push($myarr,$str);
	  
	   } //4. push the string to an array
	 
	 // a. put duplicate values into $duplicates array
	$duplicates = array_diff_assoc($myarr, array_unique($myarr));
	 
	 
	$result = array_unique($myarr);              //5. avoid any duplicate item in the array
	
	$newString = implode(',',$result);           // 6. convert the result array to string again 
    // print_r($newString);
    $newMeta = array('meta_value'=>$newString);    // 7. now update the meta_value with new string
	 		
//$this->contract_meta->update(array('contract_id' => $this->input->post('id'),'meta_key'=>'issue'),$newMeta);	
    
    
    $this->subs->update(array('id' => $existing_subscriber->id),  $newMeta);
    
  if($duplicates) {
        //$dupli = 1;
    echo '<h4>Duplicate Subscribers</h4><table class="table table-bordered">';
      $sn = 1;
      foreach($duplicates as $dup) {
     $myname =  $this->person->get_by_id($dup);
      echo '<tr><td align="center">'.$sn++.'</td>'.'<td>'.$myname->name.'</td></tr>';
       
        }
     echo '</table><div style="text-align:right;"><a href="'.base_url().'distribution/view/'.$profileID.'" class="btn btn-primary"> OK </a></div>';
    }
    
   if(!$duplicates) { echo 'no-duplicacy'; } 
    
	//echo $dupli; //json_encode(array("duplicacy" => $dupli));
	
	 } //  end of new data passed from click event checking
	 
	if(!$post['active_subscriber']) {  echo 'no-data'; } 

	}

public function mark_distributed($id)

	{
	$post = $this->input->post();
	 $printed_subscriber = $this->subs->subscriber_list($id,"subscriber");
	 $existing_subscriber = $this->subs->subscriber_list($id,"distributed");
	 $distributed_qty = $this->subs->subscriber_list($id,"distributed_qty");
	 if($existing_subscriber) { // if any delivery already occured 
	
	
	if($post['active_subscriber']) { // if any data passed from click event
	  $mystring = '';
	 if($existing_subscriber->meta_value != '') {
	$mystring = $existing_subscriber->meta_value.',';  // 1. get the meta_value with a comma as suffix..
	                                     }
	 for($i=0; $i<count($post['active_subscriber']); $i++) { // 2. loop through the submited data.
	// array_push($myarray, $post['all_subscriber'][$i]);
	  $mystring.= $post['active_subscriber'][$i];             // 3. append new item to the list 
	  if($i<count($post['active_subscriber'])-1) {$mystring.=',';}
	 }
	 $myarr = array();
	 
	 $mystring = explode(',',$mystring);
	 $printed_list = explode(',',$printed_subscriber->meta_value);
	 
	 $Difference_1 = array_diff($mystring, $printed_list); // Check string A Against String B
	$Difference_2 = array_diff($printed_list, $mystring); // Check String B against String A
	$Difference = array_merge($Difference_1, $Difference_2); // Merge the two difference arrays together 
	$left_printed_list = trim(implode(',', $Difference),","); // Convert to a string

	$new_printed_list = array('meta_value'=>$left_printed_list);
	
	 foreach($mystring as $str) { array_push($myarr,$str); } //4. push the string to an array
	$result = array_unique($myarr);              //5. avoid any duplicate item in the array
	
	$newString = trim(implode(',',$result),",");           // 6. convert the result array to string again and remove any comma from start and end
	
    // print_r($newString);
    $newMeta = array('meta_value'=>$newString);    // 7. now update the meta_value with new string
	 		    
    $newQty = ($distributed_qty->meta_value +  count($result)); // increment the distributed qty with new value
    $totalDistributed = array('meta_value'=>$newQty); 
    
    $this->subs->update(array('id' => $existing_subscriber->id),  $newMeta);
    
    $this->subs->update(array('id' => $distributed_qty->id),  $totalDistributed); // for distributed log entry
    
    $this->subs->update(array('id' => $printed_subscriber->id),  $new_printed_list);
	echo json_encode(array("status" => TRUE));
	
	 } //  end of new data passed from click event checking
	 
	 } //end of update.... if any delivery already occured
	 
if(!$existing_subscriber) { // if any delivery already occured 

if($post['active_subscriber']) { // if any data passed from click event
	
	//$mystring = $existing_subscriber->meta_value.',';  // 1. get the meta_value with a comma as suffix..
	
	 for($i=0; $i<count($post['active_subscriber']); $i++) { // 2. loop through the submited data.
	// array_push($myarray, $post['all_subscriber'][$i]);
	  $mystring.= $post['active_subscriber'][$i];             // 3. append new item to the list 
	  if($i<count($post['active_subscriber'])-1) {$mystring.=',';}
	 }
	     
    
   $insert = $this->subs->save($mystring); // execute the save function from user model
echo json_encode(array("status" => TRUE));
	
	 } //  end of new data passed from click event checking


  } // end of if any delivery not occured 

	
	}


public function mark_delivered($id)

	{
	$post = $this->input->post();
	$distributed_subscriber = $this->subs->subscriber_list($id,"distributed");
	 $existing_subscriber = $this->subs->subscriber_list($id,"delivered");
	
	 if($existing_subscriber) { // if any delivery already occured 
	
	
	if($post['active_subscriber']) { // if any data passed from click event
	  $mystring = '';
	 if($existing_subscriber->meta_value != '') {
	$mystring = $existing_subscriber->meta_value.',';  // 1. get the meta_value with a comma as suffix..
	                                     }
	 for($i=0; $i<count($post['active_subscriber']); $i++) { // 2. loop through the submited data.
	// array_push($myarray, $post['all_subscriber'][$i]);
	  $mystring.= $post['active_subscriber'][$i];             // 3. append new item to the list 
	  if($i<count($post['active_subscriber'])-1) {$mystring.=',';}
	 }
	 
	 $myarr = array();
	 
	 $mystring = explode(',',$mystring);
	 $distributed_list = explode(',',$distributed_subscriber->meta_value);
	 
	 $Difference_1 = array_diff($mystring, $distributed_list); // Check string A Against String B
	$Difference_2 = array_diff($distributed_list, $mystring); // Check String B against String A
	$Difference = array_merge($Difference_1, $Difference_2); // Merge the two difference arrays together 
	$left_distributed_list = trim(implode(',', $Difference),","); // Convert to a string
	$new_distributed_list = array('meta_value'=>$left_distributed_list);
	 
	 foreach($mystring as $str) { array_push($myarr,$str); } //4. push the string to an array
	$result = array_unique($myarr);              //5. avoid any duplicate item in the array
	
	$newString = trim(implode(',',$result),",");           // 6. convert the result array to string again 
    // print_r($newString);
    $newMeta = array('meta_value'=>$newString);    // 7. now update the meta_value with new string
	 		
//$this->contract_meta->update(array('contract_id' => $this->input->post('id'),'meta_key'=>'issue'),$newMeta);	
    
    
    $this->subs->update(array('id' => $existing_subscriber->id),  $newMeta); // upate delivered list
    $this->subs->update(array('id' => $distributed_subscriber->id), $new_distributed_list); // update distributed list(after delivered)
    //remove the subscriber from distributed list
    
    // empty the arrayt
    
    
    
    
	echo json_encode(array("status" => TRUE));
	
	 } //  end of new data passed from click event checking
	 
	 } //end of update.... if any delivery already occured
	 
if(!$existing_subscriber) { // if any delivery already occured 

if($post['active_subscriber']) { // if any data passed from click event
	
	//$mystring = $existing_subscriber->meta_value.',';  // 1. get the meta_value with a comma as suffix..
	
	 for($i=0; $i<count($post['active_subscriber']); $i++) { // 2. loop through the submited data.
	// array_push($myarray, $post['all_subscriber'][$i]);
	  $mystring.= $post['active_subscriber'][$i];             // 3. append new item to the list 
	  if($i<count($post['active_subscriber'])-1) {$mystring.=',';}
	 }
	     
    
   $insert = $this->subs->save($mystring); // execute the save function from user model
echo json_encode(array("status" => TRUE));
	
	 } //  end of new data passed from click event checking


  } // end of if any delivery not occured 

	
	}
	
public function mark_undelivered($id)

	{
	$post = $this->input->post();
	$queue_subscriber = $this->subs->subscriber_list($id,"queue");
	 $existing_subscriber = $this->subs->subscriber_list($id,"undelivered");
	
	 if($existing_subscriber) { // if any delivery already occured 
	
	
	if($post['active_subscriber']) { // if any data passed from click event
	  $mystring = '';
	 if($existing_subscriber->meta_value != '') {
	$mystring = $existing_subscriber->meta_value.',';  // 1. get the meta_value with a comma as suffix..
	                                     }
	 for($i=0; $i<count($post['active_subscriber']); $i++) { // 2. loop through the submited data.
	// array_push($myarray, $post['all_subscriber'][$i]);
	  $mystring.= $post['active_subscriber'][$i];             // 3. append new item to the list 
	  if($i<count($post['active_subscriber'])-1) {$mystring.=',';}
	 }
	  $myarr = array();
	 
	 $mystring = explode(',',$mystring);
	 $queue_list = explode(',',$queue_subscriber->meta_value);
	 
	 $Difference_1 = array_diff($mystring, $queue_list); // Check string A Against String B
	$Difference_2 = array_diff($queue_list, $mystring); // Check String B against String A
	$Difference = array_merge($Difference_1, $Difference_2); // Merge the two difference arrays together 
	$left_queue_list = trim(implode(',', $Difference),","); // Convert to a string
	$new_queue_list = array('meta_value'=>$left_queue_list);
	
	 foreach($mystring as $str) { array_push($myarr,$str); } //4. push the string to an array
	$result = array_unique($myarr);              //5. avoid any duplicate item in the array
	
	$newString = trim(implode(',',$result),",");           // 6. convert the result array to string again 
    // print_r($newString);
    $newMeta = array('meta_value'=>$newString);    // 7. now update the meta_value with new string
	 		
//$this->contract_meta->update(array('contract_id' => $this->input->post('id'),'meta_key'=>'issue'),$newMeta);	
    
    
    $this->subs->update(array('id' => $existing_subscriber->id),  $newMeta);
    $this->subs->update(array('id' => $queue_subscriber->id),  $new_queue_list);
	echo json_encode(array("status" => TRUE));
	
	 } //  end of new data passed from click event checking
	 
	 } //end of update.... if any delivery already occured
	 
if(!$existing_subscriber) { // if any delivery already occured 

if($post['active_subscriber']) { // if any data passed from click event
	
	//$mystring = $existing_subscriber->meta_value.',';  // 1. get the meta_value with a comma as suffix..
	
	 for($i=0; $i<count($post['active_subscriber']); $i++) { // 2. loop through the submited data.
	// array_push($myarray, $post['all_subscriber'][$i]);
	  $mystring.= $post['active_subscriber'][$i];             // 3. append new item to the list 
	  if($i<count($post['active_subscriber'])-1) {$mystring.=',';}
	 }
	     
    
   $insert = $this->subs->save($mystring); // execute the save function from user model
echo json_encode(array("status" => TRUE));
	
	 } //  end of new data passed from click event checking


  } // end of if any delivery not occured 

	
	}

public function mark_queue($id)

	{
	$post = $this->input->post();
	$delivered_subscriber = $this->subs->subscriber_list($id,"delivered");
	 $existing_subscriber = $this->subs->subscriber_list($id,"queue");
	
	 if($existing_subscriber) { // if any delivery already occured 
	
	
	if($post['active_subscriber']) { // if any data passed from click event
	  $mystring = '';
	 if($existing_subscriber->meta_value != '') {
	$mystring = $existing_subscriber->meta_value.',';  // 1. get the meta_value with a comma as suffix..
	                                     }
	 for($i=0; $i<count($post['active_subscriber']); $i++) { // 2. loop through the submited data.
	// array_push($myarray, $post['all_subscriber'][$i]);
	  $mystring.= $post['active_subscriber'][$i];             // 3. append new item to the list 
	  if($i<count($post['active_subscriber'])-1) {$mystring.=',';}
	 }
	  $myarr = array();
	 
	 $mystring = explode(',',$mystring);
	 $delivered_list = explode(',',$delivered_subscriber->meta_value);
	 
	 $Difference_1 = array_diff($mystring, $delivered_list); // Check string A Against String B
	$Difference_2 = array_diff($delivered_list, $mystring); // Check String B against String A
	$Difference = array_merge($Difference_1, $Difference_2); // Merge the two difference arrays together 
	$left_delivered_list = trim(implode(',', $Difference),","); // Convert to a string
	$new_delivered_list = array('meta_value'=>$left_delivered_list);
	
	 foreach($mystring as $str) { array_push($myarr,$str); } //4. push the string to an array
	$result = array_unique($myarr);              //5. avoid any duplicate item in the array
	
	$newString = trim(implode(',',$result),",");           // 6. convert the result array to string again 
    // print_r($newString);
    $newMeta = array('meta_value'=>$newString);    // 7. now update the meta_value with new string
	 		
//$this->contract_meta->update(array('contract_id' => $this->input->post('id'),'meta_key'=>'issue'),$newMeta);	
    
    
    $this->subs->update(array('id' => $existing_subscriber->id),  $newMeta);
    $this->subs->update(array('id' => $delivered_subscriber->id),  $new_delivered_list);
	echo json_encode(array("status" => TRUE));
	
	 } //  end of new data passed from click event checking
	 
	 } //end of update.... if any delivery already occured
	 
if(!$existing_subscriber) { // if any delivery already occured 

if($post['active_subscriber']) { // if any data passed from click event
	
	//$mystring = $existing_subscriber->meta_value.',';  // 1. get the meta_value with a comma as suffix..
	
	 for($i=0; $i<count($post['active_subscriber']); $i++) { // 2. loop through the submited data.
	// array_push($myarray, $post['all_subscriber'][$i]);
	  $mystring.= $post['active_subscriber'][$i];             // 3. append new item to the list 
	  if($i<count($post['active_subscriber'])-1) {$mystring.=',';}
	 }
	     
    
   $insert = $this->subs->save($mystring); // execute the save function from user model
echo json_encode(array("status" => TRUE));
	
	 } //  end of new data passed from click event checking


  } // end of if any delivery not occured 

	
	}
	

public function reverse_to_print($id)

	{
	$post = $this->input->post();
	 $printed_subscriber = $this->subs->subscriber_list($id,"subscriber");
	 $existing_subscriber = $this->subs->subscriber_list($id,"queue");
	
	 if($existing_subscriber) { // if any delivery already occured 
	
	
	if($post['active_subscriber']) { // if any data passed from click event
	  $mystring = '';
	 if($existing_subscriber->meta_value != '') {
	$mystring = $existing_subscriber->meta_value.',';  // 1. get the meta_value with a comma as suffix..
	                                     }
	 for($i=0; $i<count($post['active_subscriber']); $i++) { // 2. loop through the submited data.
	// array_push($myarray, $post['all_subscriber'][$i]);
	  $mystring.= $post['active_subscriber'][$i];             // 3. append new item to the list 
	  if($i<count($post['active_subscriber'])-1) {$mystring.=',';}
	 }
	 $myarr = array();
	 
	 $mystring = explode(',',$mystring); //list tot be reversed
	 $queue_list = explode(',',$existing_subscriber->meta_value);
	 $printed_list = explode(',',$printed_subscriber->meta_value);
	
	 $Difference_1 = array_diff($mystring, $queue_list); // Check string A Against String B
$Difference_2 = array_diff($queue_list, $mystring); // Check String B against String A
$Difference = array_merge($Difference_1, $Difference_2); // Merge the two difference arrays together 
$left_queue_list = trim(implode(',', $Difference),","); // Convert to a string
	
	$new_queue_list = array('meta_value'=>$left_queue_list);
	
	
	 foreach($mystring as $str) { array_push($printed_list,$str); } //4. push the string to an array
	$result = array_unique($printed_list);              //5. avoid any duplicate item in the array
	
	$newString = trim(implode(',',$result),",");           // 6. convert the result array to string again 
    // print_r($newString);
    $newMeta = array('meta_value'=>$newString);    // 7. now update the meta_value with new string
	 		
//$this->contract_meta->update(array('contract_id' => $this->input->post('id'),'meta_key'=>'issue'),$newMeta);	
    
    
    $this->subs->update(array('id' => $printed_subscriber->id),  $newMeta);
    $this->subs->update(array('id' => $existing_subscriber->id),  $new_queue_list);
	echo json_encode(array("status" => TRUE));
	
	 } //  end of new data passed from click event checking
	 
	 } //end of update.... if any delivery already occured
	 


	
	}

public function mark_queue_again($id)

	{
	$post = $this->input->post();
	$undelivered_subscriber = $this->subs->subscriber_list($id,"undelivered");
	 $existing_subscriber = $this->subs->subscriber_list($id,"queue");
	
	 if($existing_subscriber) { // if any delivery already occured 
	
	
	if($post['active_subscriber']) { // if any data passed from click event
	  $mystring = '';
	 if($existing_subscriber->meta_value != '') {
	$mystring = $existing_subscriber->meta_value.',';  // 1. get the meta_value with a comma as suffix..
	                                     }
	 for($i=0; $i<count($post['active_subscriber']); $i++) { // 2. loop through the submited data.
	// array_push($myarray, $post['all_subscriber'][$i]);
	  $mystring.= $post['active_subscriber'][$i];             // 3. append new item to the list 
	  if($i<count($post['active_subscriber'])-1) {$mystring.=',';}
	 }
	  $myarr = array();
	 
	 $mystring = explode(',',$mystring);
	 $undelivered_list = explode(',',$undelivered_subscriber->meta_value);
	 
	 $Difference_1 = array_diff($mystring, $undelivered_list); // Check string A Against String B
	$Difference_2 = array_diff($undelivered_list, $mystring); // Check String B against String A
	$Difference = array_merge($Difference_1, $Difference_2); // Merge the two difference arrays together 
	$left_undelivered_list = trim(implode(',', $Difference),","); // Convert to a string
	$new_undelivered_list = array('meta_value'=>$left_undelivered_list);
	
	 foreach($mystring as $str) { array_push($myarr,$str); } //4. push the string to an array
	$result = array_unique($myarr);              //5. avoid any duplicate item in the array
	
	$newString = trim(implode(',',$result),",");           // 6. convert the result array to string again 
    // print_r($newString);
    $newMeta = array('meta_value'=>$newString);    // 7. now update the meta_value with new string
	 		
//$this->contract_meta->update(array('contract_id' => $this->input->post('id'),'meta_key'=>'issue'),$newMeta);	
    
    
    $this->subs->update(array('id' => $existing_subscriber->id),  $newMeta);
    $this->subs->update(array('id' => $undelivered_subscriber->id),  $new_undelivered_list);
	echo json_encode(array("status" => TRUE));
	
	 } //  end of new data passed from click event checking
	 
	 } //end of update.... if any delivery already occured
	 
if(!$existing_subscriber) { // if any delivery already occured 

if($post['active_subscriber']) { // if any data passed from click event
	
	//$mystring = $existing_subscriber->meta_value.',';  // 1. get the meta_value with a comma as suffix..
	
	 for($i=0; $i<count($post['active_subscriber']); $i++) { // 2. loop through the submited data.
	// array_push($myarray, $post['all_subscriber'][$i]);
	  $mystring.= $post['active_subscriber'][$i];             // 3. append new item to the list 
	  if($i<count($post['active_subscriber'])-1) {$mystring.=',';}
	 }
	     
    
   $insert = $this->subs->save($mystring); // execute the save function from user model
echo json_encode(array("status" => TRUE));
	
	 } //  end of new data passed from click event checking


  } // end of if any delivery not occured 

	
	}


public function remove_subscriber($id)
{


	$post = $this->input->post();
	 $printed_subscriber = $this->subs->subscriber_list($id,"subscriber");
	// $existing_subscriber = $this->subs->subscriber_list($id,"distributed");
	
	 
	
	
	if($post['active_subscriber']) { // if any data passed from click event
	  $mystring = '';
	 
	 for($i=0; $i<count($post['active_subscriber']); $i++) { // 2. loop through the submited data.
	// array_push($myarray, $post['all_subscriber'][$i]);
	  $mystring.= $post['active_subscriber'][$i];             // 3. append new item to the list 
	  if($i<count($post['active_subscriber'])-1) {$mystring.=',';}
	 }
	 $myarr = array();
	 
	 $mystring = explode(',',$mystring);
	 $printed_list = explode(',',$printed_subscriber->meta_value);
	 
	 $Difference_1 = array_diff($mystring, $printed_list); // Check string A Against String B
$Difference_2 = array_diff($printed_list, $mystring); // Check String B against String A
$Difference = array_merge($Difference_1, $Difference_2); // Merge the two difference arrays together 
$left_printed_list = trim(implode(',', $Difference),","); // Convert to a string
	$new_printed_list = array('meta_value'=>$left_printed_list);
	
	
    $this->subs->update(array('id' => $printed_subscriber->id),  $new_printed_list);
	echo json_encode(array("status" => TRUE));
	
	 } //  end of new data passed from click event checking
	 
	
}





public function ready_for_print()

	{ 
	$post = $this->input->post();
		
	if($post['active_subscriber']) { // if any data passed from click event
 
	  $mystring = '';
	 
	 for($i=0; $i<count($post['active_subscriber']); $i++) { // 2. loop through the submited data.
	// array_push($myarray, $post['all_subscriber'][$i]);
	  $mystring.= $post['active_subscriber'][$i];             // 3. append new item to the list 
	  if($i<count($post['active_subscriber'])-1) {$mystring.=',';}
	 }
	 $myarr = array();
	 $mystring = explode(',',$mystring);
	 foreach($mystring as $str) { array_push($myarr,$str); } //4. push the string to an array
	$data['subscriberList'] = array_unique($myarr);              //5. avoid any duplicate item in the array
	//$subscriberList = array_unique($myarr);
         //print_r($subscriberList);
         
	


  } // if any data passed from subscriber form

	$this->load->view('distribution/ready_for_printing',$data);
	}

public function print_by_method($profileID,$method) // print by distribution method(i.e: sundarban courier, DHL, Skenet etc.)


	{
	 //$method_subscriber = $this->person->get_by_method($method);
	 
	 $existing_subscriber = $this->subs->subscriber_list($profileID,"subscriber");
	
	 if($existing_subscriber) { // if any subscriber in this profile id
	
		
	  $m = array();
		 	  
	 
	$mystring = $existing_subscriber->meta_value;  // 1. get the meta_value with a comma as suffix..
	                     
	$mystring = explode(',',$mystring);
	 foreach($mystring as $str) {
	 
	  array_push($m,$str);
	  
	   }            
	
		
	$data['subscriberList'] = array_unique($m);
	$data['method'] = $method;
	$this->load->view('distribution/print_by_method',$data);


  } // end of if any subscriber in this profile id
 
	
	}

public function download_by_method($profileID,$method) // print by distribution method(i.e: sundarban courier, DHL, Skenet etc.)


	{
	 //$method_subscriber = $this->person->get_by_method($method);
	 
	 $existing_subscriber = $this->subs->subscriber_list($profileID,"subscriber");
	
	 if($existing_subscriber) { // if any subscriber in this profile id
	
		
	  $m = array();
		 	  
	 
	$mystring = $existing_subscriber->meta_value;  // 1. get the meta_value with a comma as suffix..
	                     
	$mystring = explode(',',$mystring);
	 foreach($mystring as $str) {
	 
	  array_push($m,$str);
	  
	   }            
	
		
	$data['subscriberList'] = array_unique($m);
	$data['method'] = $method;
	$this->load->view('distribution/download_by_method',$data);


  } // end of if any subscriber in this profile id
 
	
	}


// for all subscriber list of any publication....
public function list_by_tag($tag,$pub) // list all subscriber by type,category,group
	 {
	   $data['pub_id'] = $pub;

	   //var_dump($tag);
	 $this->load->view('distribution/list_by_'.$tag.'',$data);
	
	 }


// for all subscriber list of any publication....
public function subscriber_list($pub)
	 {
	 
	  $mydata['searchInfo'] = $this->person->custom_search_result_dis($pub);

	  // var_dump($mydata['searchInfo']);
	// $mydata['subscriberList'] = $this->subs->subscriber_list($profile_id);
         
        
	 $this->load->view('distribution/total_subscriber_list',$mydata);
	
	 }
public function subscriber_list_expired($pub)
	 {
	 
	  $mydata['searchInfo1'] = $this->person->custom_search_result_dis_expired($pub);


	  // var_dump($mydata['searchInfo1']);
	// $mydata['subscriberList'] = $this->subs->subscriber_list($profile_id);
         
        
	 $this->load->view('distribution/total_subscriber_list_expired',$mydata);
	
	 }

public function distributed_list($id)
  {
    $mydata['distributionInfo'] = $this->distribute->get_by_id($id);
    $mydata['distributedList'] = $this->subs->subscriber_list($id,"distributed");
    $this->load->view('distribution/distributed_list',$mydata);
  }

public function delivered_list($id)
  { 
  $mydata['distributionInfo'] = $this->distribute->get_by_id($id);
    $mydata['deliveredList'] = $this->subs->subscriber_list($id,"delivered");
    $this->load->view('distribution/delivered_list',$mydata);
  }

public function undelivered_list($id)
  { 
  $mydata['distributionInfo'] = $this->distribute->get_by_id($id);
    $mydata['undeliveredList'] = $this->subs->subscriber_list($id,"undelivered");
    $this->load->view('distribution/undelivered_list',$mydata);
  }

public function queue_list($id)
  {
  $mydata['distributionInfo'] = $this->distribute->get_by_id($id);
    $mydata['queueList'] = $this->subs->subscriber_list($id,"queue");
    $this->load->view('distribution/queue_list',$mydata);
  }


	public function ajax_add()

	{
	
	$this->_validate();

		

		$data = array(
                'title' => $this->input->post('title'),
				'description' => $this->input->post('description'),

				'publication_id' => $this->input->post('publication_id'),

				   );
		$insert = $this->distribute->save($data); // execute the save function from user model
		
		$subscriber_list = array('profile_id'=>$insert, 'meta_key'=>'subscriber', 'meta_value'=>'');
		$distributed_list = array('profile_id'=>$insert, 'meta_key'=>'distributed', 'meta_value'=>'');
		$delivered_list = array('profile_id'=>$insert, 'meta_key'=>'delivered', 'meta_value'=>'');
		$undelivered_list = array('profile_id'=>$insert, 'meta_key'=>'undelivered', 'meta_value'=>'');
		$queue_list = array('profile_id'=>$insert, 'meta_key'=>'queue', 'meta_value'=>'');
		
		$distributed_qty = array('profile_id'=>$insert, 'meta_key'=>'distributed_qty', 'meta_value'=>'0');
		
		
        $insert_subscriber = $this->subs->save($subscriber_list); // execute the save function from user model
		 $insert_distributed = $this->subs->save($distributed_list); // execute the save function from user model
         $insert_delivered = $this->subs->save($delivered_list); // execute the save function from user model
         $insert_undelivered = $this->subs->save($undelivered_list); // execute the save function from user model
		 $insert_queue = $this->subs->save($queue_list); // execute the save function from user model
	
	 $insert_distributed_qty = $this->subs->save($distributed_qty); // execute the save function from user model
		 
		echo json_encode(array('id'=>$insert,"status" => TRUE));

	}

	public function custom_search($pub)
	 {
	  $myprev = $this->privilege->get_by_userid($this->session->userdata('id'));
	 $valid = $myprev->distribution_crud;
	 $mydata['mypermission'] = $valid;
	 //$data = $this->input->post('publication_id');
	 $mydata['pubsInfo'] = $this->pubs->get_all();
	 $mydata['searchInfo'] = $this->distribute->custom_search_result($pub);
         $mydata['pubID'] = $pub;
        
	 $this->load->view('distribution/distribution_by_publication',$mydata);
	
	 }

public function edit_distribution_profile($id)

	{
   $myprev = $this->privilege->get_by_userid($this->session->userdata('id'));
	 $valid = $myprev->distribution_crud;
	 if($valid == '0')  {
		 
            $this->session->set_flashdata('flash_data', 'You don\'t have access!');
            redirect('dashboard/no_access');
			//exit();
			 
        }
		else {
		$data['distInfo'] = $this->distribute->get_by_id($id);

		/*$data = array('id'=>$type_info->id, 
                      'publication_id' => $type_info->publication_id,
		               'title'=>$type_info->title,

					   'description'=>$type_info->description
                                            

					  );*/
		//echo json_encode($data);
    $data['pubsInfo'] = $this->pubs->get_all();
		
		$this->load->view('distribution/edit_distribution_profile',$data);

         
		 }
	}

public function update_distribution_profile()
	     {
	   
	    
		$data = array(
		        'publication_id' => $this->input->post('publication_id'),
				'title' => $this->input->post('title'),
				'description' => $this->input->post('description')
                              
				
			);

		$this->distribute->update(array('id' => $this->input->post('id')), $data);

		echo json_encode(array("status" => TRUE,'pub_id'=>$this->input->post('publication_id')));

	     }	




public function view($id=NULL)

	 {
      $myprev = $this->privilege->get_by_userid($this->session->userdata('id'));
	 $valid = $myprev->distribution_crud;
	 if($valid == '0')  {
		 
            $this->session->set_flashdata('flash_data', 'You don\'t have access!');
            redirect('dashboard/no_access');
			//exit();
			 
        }
		else {
	 $contact_info['distributionInfo'] = $this->distribute->get_by_id($id);

	 

	 $this->load->view('distribution/distribution_details',$contact_info);

	 }  
	     }


	public function contract_update($id=NULL)

	 {
		$data['advInfo'] = $this->adv->get_all();
		$data['posInfo'] = $this->position->get_all();
		$data['pubsInfo'] = $this->pubs->get_all();
		$data['contraInfo'] = $this->contra->get_by_id($id);


		$this->load->view('contract/contract_profile',$data);

	 }

	public function details($id=NULL)

	 {
	$data['distributionInfo'] = $this->distribute->get_by_id($id);
	 $this->load->view('distribution/distribution_details',$data);

	 }
	 
	public function summary($id=NULL)

	 {
 
 $data['distributionInfo'] = $this->distribute->get_by_id($id);
  $data['subscriberList'] = $this->subs->subscriber_list($id,"subscriber");

	 $this->load->view('distribution/distribution_summary',$data);

	 }



public function close_contract($id=NULL)

	{
	$data = array('status' => 'closed');
    $this->contra->update(array('id' => $id), $data);
   echo json_encode(array("status" => TRUE));

	}

public function cancel_contract($id=NULL)

	{
	$data = array('status' => 'cancelled');
    $this->contra->update(array('id' => $id), $data);
   echo json_encode(array("status" => TRUE));

	}
public function activate_contract($id=NULL)

	{
	$data = array('status' => 'active');
    $this->contra->update(array('id' => $id), $data);
   echo json_encode(array("status" => TRUE));

	}
public function activity($id=NULL)

	 {
         $contact_info['contractInfo'] = $this->contra->get_by_id($id);
	 $contact_info['activityInfo'] = $this->activity->get_by_contract($id);

	 

	 $this->load->view('contract/contract_activity',$contact_info);

	 }

	public function add_distribution()

	 {
	   
     $myprev = $this->privilege->get_by_userid($this->session->userdata('id'));
	 $valid = $myprev->distribution_crud;
	 if($valid == '0')  {
		 
            $this->session->set_flashdata('flash_data', 'You don\'t have access!');
            redirect('dashboard/no_access');
			//exit();
			 
        }
		else {
	 $data['pubsInfo'] = $this->pubs->get_all();
 
	 $this->load->view('distribution/add_distribution',$data);

	 
   }
	 }


	public function ajax_update()

	{
	
	$this->_validate();
	
	
		
		$data = array(

				'title' => $this->input->post('title'),
				'description' => $this->input->post('description'),

				'publication_id' => $this->input->post('publication_id'),
			);

			

		$this->distribute->update(array('id' => $this->input->post('id')), $data);


		
		echo json_encode(array("status" => TRUE));

	}



	public function ajax_delete($id)

	{

		$this->distribute->delete_by_id($id);
		//$this->subs->delete_by_meta($id); // delete by profile id

		echo json_encode(array("status" => TRUE));

	}





	private function _validate()

	{

		$data = array();

		$data['error_string'] = array();

		$data['inputerror'] = array();

		$data['status'] = TRUE;

   
if($this->input->post('publication_id') == '0' )

		{

			$data['inputerror'][] = 'publication_id';

			$data['error_string'][] = 'Select Publication';

			$data['status'] = FALSE;

		}


		if($this->input->post('title') == '' )

		{

			$data['inputerror'][] = 'title';

			$data['error_string'][] = 'Title required';

			$data['status'] = FALSE;

		}
	


		if($data['status'] === FALSE)

		{

			echo json_encode($data);

			exit();

		}

	}

private function _validate_payment()

	{

		$data = array();

		$data['error_string'] = array();

		$data['inputerror'] = array();

		$data['status'] = TRUE;

   



		if($this->input->post('amount') == '' || !is_numeric($this->input->post('amount')) )

		{

			$data['inputerror'][] = 'amount';

			$data['error_string'][] = 'Invalid Amount';

			$data['status'] = FALSE;

		}
	
if($this->input->post('payment_date') == '' )

		{

			$data['inputerror'][] = 'payment_date';

			$data['error_string'][] = 'Invalid date';

			$data['status'] = FALSE;

		}


		if($data['status'] === FALSE)

		{

			echo json_encode($data);

			exit();

		}

	}

	

	



}