<?php 
defined('BASEPATH') OR exit('No direct script access allowed');

class User extends CI_Controller {

	public function __construct()
	{
		parent::__construct();
		 if(empty($this->session->userdata('id')) ) {
            $this->session->set_flashdata('flash_data', 'You don\'t have access!');
            redirect('login');
        }
		
		
		$this->load->model('user_model','person');
		$this->load->model('group_model','group');
		
		$this->load->model('UserPrivileges_model','priv');
		$this->load->helper('url');
		$this->load->library('upload'); // to upload image
	}

	public function index()
	{
	  
		$data['userInfo'] = $this->person->get_all();
		//$myprev = $this->priv->get_by_userid($this->session->userdata('id'));
		$this->load->view('user/all_users',$data);
	 }

public function add_user()
	{
		 $myprev = $this->priv->get_by_userid($this->session->userdata('id'));
	 $valid = $myprev->user_menu;
	 if($valid == '0')  {
		 
            $this->session->set_flashdata('flash_data', 'You don\'t have access!');
            redirect('dashboard/no_access');
			//exit();
        }
		else{
		$data['groupInfo'] = $this->group->get_all();
		$this->load->view('user/add_user',$data);
		}
	    }
	public function edit($id)
	{
	   
		 $data['groupInfo'] = $this->group->get_all();
		$data['user'] = $this->person->get_by_id($id);
		$this->load->view('user/edit_user',$data);
	
	  }

public function view($id)
	{
		
		$data['user'] = $this->person->get_by_id($id);
		$this->load->view('user/view_user',$data);
	}


	public function add_new()
	{
		$this->_validate();
		$data = array(
				'first_name' => $this->input->post('first_name'),
				'last_name' => $this->input->post('last_name'),
				'email' => $this->input->post('email'),
				'phone' => $this->input->post('phone'),
				'username' => $this->input->post('username'),
				'password' => md5($this->input->post('password')),
				'status' => $this->input->post('status'),
				'group_id' => $this->input->post('group'),
				'user_photo' => $this->input->post('user_photo'),
	                  );
		$insert = $this->person->save($data); // execute the save function from user model
		
// user privileges....

 $privileges_data = array(
				'company_id' => 1, //$this->input->post('company'),
				'user_id' => $insert,
				
				'publication_menu' => $this->input->post('publication_menu'),
				'publication_crud' => $this->input->post('publication_crud'),
				'publication_report' => $this->input->post('publication_report'),
				
				'advertiser_menu' => $this->input->post('advertiser_menu'),
				'advertiser_crud' => $this->input->post('advertiser_crud'),
				
				'contract_menu' => $this->input->post('contract_menu'),
				'contract_crud' => $this->input->post('contract_crud'),
				
				'subscription_menu' => $this->input->post('subscription_menu'),
				'subscription_crud' => $this->input->post('subscription_crud'),
				'subscription_report' => $this->input->post('subscription_report'),
				
				'subscriber_menu' => $this->input->post('subscriber_menu'),
				'subscriber_crud' => $this->input->post('subscriber_crud'),
				'subscriber_report' => $this->input->post('subscriber_report'),
				
				'distribution_menu' => $this->input->post('distribution_menu'),
				'distribution_crud' => $this->input->post('distribution_crud'),
				
				'user_menu' => $this->input->post('user_menu'),
				'user_crud' => $this->input->post('user_crud'),
				
				'created' => date('Y-m-d'),
				'created_by' => $this->input->post('created_by'),
				
				'modified' => date('Y-m-d'),
				'modified_by' => $this->input->post('modified_by'),
			);
		
		$insert_privileges = $this->priv->save($privileges_data); // execute the save function from user model
echo json_encode(array("status" => TRUE,'user_id'=>$insert));
	}
	public function update_user()
	{
	  if($this->input->post('password_checker')==0) { $pass = $this->input->post('password'); }
	  if($this->input->post('password_checker')==1) { $pass = md5($this->input->post('password')); }
		$this->_validate();
		$data = array(
				'first_name' => $this->input->post('first_name'),
				'last_name' => $this->input->post('last_name'),
				'email' => $this->input->post('email'),
				'phone' => $this->input->post('phone'),
				'username' => $this->input->post('username'),
				'password' => $pass,
				'status' => $this->input->post('status'),
				'group_id' => $this->input->post('group'),
				'user_photo' => $this->input->post('user_photo'),
			);	
		$this->person->update(array('id' => $this->input->post('id')), $data);
		echo json_encode(array("status" => TRUE));
	}
	


	public function delete_user($id)
	{
		$this->person->delete_by_id($id);
		echo json_encode(array("status" => TRUE));
	}

// user previliges....//////////
public function user_privileges($id)
{
        $data['user'] = $this->person->get_by_id($id);
		$data['priv'] = $this->priv->get_by_userid($id);
		$this->load->view('user/user_privileges',$data);


}

public function update_privileges($id)
 {
 
 $data = array(
				'company_id' => 1, //$this->input->post('company'),
				'user_id' => $this->input->post('user_id'),
				
				'publication_menu' => $this->input->post('publication_menu'),
				'publication_crud' => $this->input->post('publication_crud'),
				'publication_report' => $this->input->post('publication_report'),
				
				'advertiser_menu' => $this->input->post('advertiser_menu'),
				'advertiser_crud' => $this->input->post('advertiser_crud'),
				
				'contract_menu' => $this->input->post('contract_menu'),
				'contract_crud' => $this->input->post('contract_crud'),
				
				'subscription_menu' => $this->input->post('subscription_menu'),
				'subscription_crud' => $this->input->post('subscription_crud'),
				'subscription_report' => $this->input->post('subscription_report'),
				
				'subscriber_menu' => $this->input->post('subscriber_menu'),
				'subscriber_crud' => $this->input->post('subscriber_crud'),
				'subscriber_report' => $this->input->post('subscriber_report'),
				
				'distribution_menu' => $this->input->post('distribution_menu'),
				'distribution_crud' => $this->input->post('distribution_crud'),
				
				'user_menu' => $this->input->post('user_menu'),
				'user_crud' => $this->input->post('user_crud'),
				
				'created' => $this->input->post('created'),
				'created_by' => $this->input->post('created_by'),
				
				'modified' => date('Y-m-d'),
				'modified_by' => $this->input->post('modified_by'),
			);
		
		$this->priv->update(array('user_id' => $this->input->post('user_id')), $data);
	
		echo json_encode(array("status" => TRUE));
 
 
 }
 
  public function new_upload() // upload for new transaction
	 {
	if(isset($_FILES["userFile"]) && $_FILES["userFile"]["error"]== UPLOAD_ERR_OK)
{
	############ Edit settings ##############
	$UploadDirectory	= 'uploads/user/'; //specify upload directory ends with / (slash)
	##########################################
	
	/*
	Note : You will run into errors or blank page if "memory_limit" or "upload_max_filesize" is set to low in "php.ini". 
	Open "php.ini" file, and search for "memory_limit" or "upload_max_filesize" limit 
	and set them adequately, also check "post_max_size".
	*/
	
	//check if this is an ajax request
	if (!isset($_SERVER['HTTP_X_REQUESTED_WITH'])){
		die();
	}
	
	
	//Is file size is less than allowed size.
	if ($_FILES["userFile"]["size"] > 500000) { // max 5 MB
		die("<font color='#ff0000'>File size is too big!</font>");
	}
	
	//allowed file type Server side check
	switch(strtolower($_FILES['userFile']['type']))
		{
			//allowed file types
            
			 case 'image/png': 
			case 'image/gif': 
			case 'image/jpeg':
			case 'image/jpg': 
			case 'image/pjpeg':
			/*case 'text/plain':
			case 'text/html':
			case 'application/x-zip-compressed':
			case 'application/pdf':
			case 'application/msword':
			case 'application/vnd.ms-excel':
			case 'video/mp4':*/
			
				break;
			default:
				die('<font color="#ff0000">Unsupported File! </font>'); //output error
	}
	
	$File_Name          = strtolower($_FILES['userFile']['name']);
	$File_Ext           = substr($File_Name, strrpos($File_Name, '.')); //get file extention
	$Random_Number      = rand(0, 9999999999); //Random number to be added to name.
	$NewFileName 		= $Random_Number.$File_Ext; //new file name
	$targetPath = "uploads/user/".$NewFileName;

	if(move_uploaded_file($_FILES['userFile']['tmp_name'], $targetPath))
	   {
	  	   
$response = $NewFileName;
echo $response;
	}
	
	else{
		die('<font color="#ff0000">error uploading File!</font>');
	}
	
}
else
{
	die('Something wrong with upload! Is "upload_max_filesize" set correctly?');
}
	

	 
 }	 
 
 public function edit_upload($userid) // upload for new transaction
	 {
	if(isset($_FILES["userFile"]) && $_FILES["userFile"]["error"]== UPLOAD_ERR_OK)
{
	############ Edit settings ##############
	$UploadDirectory	= 'uploads/user/'; //specify upload directory ends with / (slash)
	##########################################
	
	/*
	Note : You will run into errors or blank page if "memory_limit" or "upload_max_filesize" is set to low in "php.ini". 
	Open "php.ini" file, and search for "memory_limit" or "upload_max_filesize" limit 
	and set them adequately, also check "post_max_size".
	*/
	
	//check if this is an ajax request
	if (!isset($_SERVER['HTTP_X_REQUESTED_WITH'])){
		die();
	}
	
	
	//Is file size is less than allowed size.
	if ($_FILES["userFile"]["size"] > 500000) { // max 5 MB
		die("<font color='#ff0000'>File size is too big!</font>");
	}
	
	//allowed file type Server side check
	switch(strtolower($_FILES['userFile']['type']))
		{
			//allowed file types
            
			 case 'image/png': 
			case 'image/gif': 
			case 'image/jpeg':
			case 'image/jpg': 
			case 'image/pjpeg':
			/*case 'text/plain':
			case 'text/html':
			case 'application/x-zip-compressed':
			case 'application/pdf':
			case 'application/msword':
			case 'application/vnd.ms-excel':
			case 'video/mp4':*/
			
				break;
			default:
				die('<font color="#ff0000">Unsupported File! </font>'); //output error
	}
	
	$File_Name          = strtolower($_FILES['userFile']['name']);
	$File_Ext           = substr($File_Name, strrpos($File_Name, '.')); //get file extention
	$Random_Number      = rand(0, 9999999999); //Random number to be added to name.
	$NewFileName 		= $Random_Number.$File_Ext; //new file name
	$targetPath = "uploads/user/".$NewFileName;

	if(move_uploaded_file($_FILES['userFile']['tmp_name'], $targetPath))
	   {
	  	   $datai = array('user_photo' => $NewFileName);
$this->person->update(array('id' => $userid), $datai);
$response = $NewFileName;
echo $response;
	}
	
	else{
		die('<font color="#ff0000">error uploading File!</font>');
	}
	
}
else
{
	die('Something wrong with upload! Is "upload_max_filesize" set correctly?');
}
	

	 
 }	 
 
 public function delete_file($filename)
  {
  $absolutedir			= dirname(__FILE__);
//$absolutedir = str_replace('\controllers','',$absolutedir);
$upload_dir = str_replace('application\controllers','',$absolutedir);
$dir					= 'uploads\user\\';
$serverdir				= $upload_dir.$dir;
  
 unlink($serverdir.$filename ); // remove the existing file


  }	
 
////////////////////////////////////
	private function _validate()
	{
		$data = array();
		$data['error_string'] = array();
		$data['inputerror'] = array();
		$data['status'] = TRUE;

		if($this->input->post('first_name') == '')
		{
			$data['inputerror'][] = 'first_name';
			$data['error_string'][] = 'First name is required';
			$data['status'] = FALSE;
		}

		if($this->input->post('last_name') == '')
		{
			$data['inputerror'][] = 'last_name';
			$data['error_string'][] = 'Last name is required';
			$data['status'] = FALSE;
		}

		if($this->input->post('email') == '')
		{
			$data['inputerror'][] = 'email';
			$data['error_string'][] = 'Addess is required';
			$data['status'] = FALSE;
		}

		if($this->input->post('phone') == '')
		{
			$data['inputerror'][] = 'phone';
			$data['error_string'][] = 'Please select gender';
			$data['status'] = FALSE;
		}

		

		if($data['status'] === FALSE)
		{
			echo json_encode($data);
			exit();
		}
	}
	
	

}
