<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class AdvertiserActivity_model extends CI_Model {

	var $table = 'activity';
	//var $column = array('contact_id','activity_date','title','details'); //set column field database for order and search
	var $order = array('id' => 'desc'); // default order 

	public function __construct()
	{
		parent::__construct();
		$this->load->database();
		
	}

	public function count_all()
	{
		$this->db->from($this->table);
		return $this->db->count_all_results();
	}

	public function get_by_id($id)
	{
		$this->db->from($this->table);
		$this->db->where('id',$id);
		$query = $this->db->get();

		return $query->row(); // show only the first result...
	}
	
	public function get_by_advertiser($subid) // activity_for = subscriber
	{
		$this->db->from($this->table);
		$this->db->where('activity_for= "advertiser" and object_id="'.$subid.'"');
		$query = $this->db->get();

		return $query->result();
	}
	
	public function save($data)
	{
		$this->db->insert($this->table, $data);
		return $this->db->insert_id();
	}

	public function update($where, $data)
	{
		$this->db->update($this->table, $data, $where);
		return $this->db->affected_rows();
	}
	
	public function delete_by_id($id)
	{
		$this->db->where('id', $id);
		$this->db->delete($this->table);
	}
	

}
