<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Contract_model extends CI_Model {

	var $table = 'advertisement_contract';
	var $column = array('reference_no'); //set column field database for order and search
	var $order = array('id' => 'desc'); // default order 

	public function __construct()
	{
		parent::__construct();
		$this->load->database();
		
	}

	private function _get_datatables_query()
	{
		
		$this->db->from($this->table);
		
		$i = 0;
	
		foreach ($this->column as $item) // loop column 
		{
			if($_POST['search']['value']) // if datatable send POST for search
			{
				
				if($i===0) // first loop
				{
					$this->db->group_start(); // open bracket. query Where with OR clause better with bracket. because maybe can combine with other WHERE with AND. 
					$this->db->like($item, $_POST['search']['value']);
				}
				else
				{
					$this->db->or_like($item, $_POST['search']['value']);
				}

				if(count($this->column) - 1 == $i) //last loop
					$this->db->group_end(); //close bracket
			}
			$column[$i] = $item; // set column array variable to order processing
			$i++;
		}
		
		if(isset($_POST['order'])) // here order processing
		{
			$this->db->order_by($column[$_POST['order']['0']['column']], $_POST['order']['0']['dir']);
		} 
		else if(isset($this->order))
		{
			$order = $this->order;
			$this->db->order_by(key($order), $order[key($order)]);
		}
	}

	function get_datatables()
	{
		$this->_get_datatables_query();
		if($_POST['length'] != -1)
		$this->db->limit($_POST['length'], $_POST['start']);
		
		$query = $this->db->get();
		return $query->result();
	}
	
	public function get_all()
	{
		$this->db->from($this->table);
		
		$query = $this->db->get();

		return $query->result();
	}
	
	

	function count_filtered()
	{
		$this->_get_datatables_query();
		$query = $this->db->get();
		return $query->num_rows();
	}

	public function count_all()
	{
		$this->db->from($this->table);
		
		return $this->db->count_all_results();
	}

	public function get_by_id($id)
	{
		$this->db->from($this->table);
		$this->db->where('id',$id);
		$query = $this->db->get();

		return $query->row();
	}
	
public function totalContract()
	{
		$pub_query = $this->db->query('select count(id) as totalContra from advertisement_contract where status="active"');
		
		$query = $pub_query->row();
		return $query->totalContra;
	}

public function weeklyContract()
	{
	$start = date('Y-m-d',strtotime('-7 days'));
	$end = date('Y-m-d');
		$pub_query = $this->db->query('select count(id) as weekly_contract from advertisement_contract where status="active" and contract_date between"'.$start.'" and "'.$end.'"');
		
		$query = $pub_query->row();
		return $query->weekly_contract;
	}

public function custom_search_result($mystring){
        $this->db->from($this->table);
$this->db->where('publication_id = '.$mystring); // deposit = ac_from(0)		

		$query = $this->db->get();
		return $query->result();

    }
    
public function advertiser_statistics($start,$end)
  {
  
  $year = date("Y",strtotime($start));
   $month = date("M",strtotime($start));
   $day = date("D",strtotime($start));
   
   $diff=date_diff($start,$end);
  
 
$sub_query = $this->db->query( "SELECT payment_date, amount from payment where payment_for = 'contract' and  payment_date BETWEEN  '".$start."' AND  '".$end."' order by payment_date asc "); 

$sub =  $sub_query->result();
  return $sub;
  }


	public function save($data)
	{
		$this->db->insert($this->table, $data);
		return $this->db->insert_id();
	}

	public function update($where, $data)
	{
		$this->db->update($this->table, $data, $where);
		return $this->db->affected_rows();
	}
	
	public function delete_by_id($id)
	{
		$this->db->where('id', $id);
		$this->db->delete($this->table);
	}
	
	
	

}
