<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class UserGroup_model extends CI_Model {

	var $table = 'users_groups';
	//var $column = array('name','description'); //set column field database for order and search
	var $order = array('id' => 'desc'); // default order 

	public function __construct()
	{
		parent::__construct();
		$this->load->database();
		
	}


	public function count_all()
	{
		$this->db->from($this->table);
		return $this->db->count_all_results();
	}

	public function get_by_userid($user_id)
	{
		$this->db->from($this->table);
		$this->db->where('user_id',$user_id);
		$query = $this->db->get();

		return $query->row();
	}
	
	public function get_all()
	{
		$this->db->from($this->table);
		
		$query = $this->db->get();

		return $query->result();
	}

	public function save($data)
	{
		$this->db->insert($this->table, $data);
		return $this->db->insert_id();
	}

	public function update($where, $data)
	{
		$this->db->update($this->table, $data, $where);
		return $this->db->affected_rows();
	}

	public function delete_by_id($id)
	{
		$this->db->where('id', $id);
		$this->db->delete($this->table);
	}
	
	
	
}
