<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class DistributionMeta_model extends CI_Model {

	var $table = 'distribution_meta';
	//var $column = array('reference_no'); //set column field database for order and search
	var $order = array('id' => 'desc'); // default order 

	public function __construct()
	{
		parent::__construct();
		$this->load->database();
		
	}

	
	
	public function get_all()
	{
		$this->db->from($this->table);
		
		$query = $this->db->get();

		return $query->result();
	}


	public function count_all()
	{
		$this->db->from($this->table);
		
		return $this->db->count_all_results();
	}

	public function get_by_id($id)
	{
		$this->db->from($this->table);
		$this->db->where('id',$id);
		$query = $this->db->get();

		return $query->row();
	}

public function subscriber_list($profile_id,$key) // list of subscriber in any distribution profile
	{
		$this->db->from($this->table);
		$this->db->where('profile_id= "'.$profile_id.'" and meta_key ="'.$key.'"');
		$query = $this->db->get();

		return $query->row();
	}

public function subscriber_list_expired($profile_id,$key) // list of subscriber in any distribution profile
	{
		$this->db->from($this->table);
		$this->db->where('profile_id= "'.$profile_id.'" and meta_key ="'.$key.'"');
		$query = $this->db->get();

		return $query->row();
	}


	public function save($data)
	{
		$this->db->insert($this->table, $data);
		return $this->db->insert_id();
	}

	public function update($where, $data)
	{
		$this->db->update($this->table, $data, $where);
		return $this->db->affected_rows();
	}
	
	public function delete_by_id($id)
	{
		$this->db->where('id', $id);
		$this->db->delete($this->table);
	}
	
	public function delete_by_meta($id)
	{
		$this->db->where('profile_id', $id);
		$this->db->delete($this->table);
	}
	
	
	

}